class  AGUI_BUTTON
   
   
inherit
   AGUI_LABEL_BASE
      redefine
	 efox__callback_command
      end
   
   
creation
   {ANY} make, make_initial_default

creation
   {AGUI_APPLICATION} make_internal
   
   
feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_button__make(Current,p.handle, n.to_external, $temp_px,false)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   make_initial_default (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_button__make(Current,p.handle, n.to_external, $temp_px,true)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
   
   make_internal (hashkey: INTEGER; hnd: POINTER) is
      require
	 hnd /= default_pointer
      do
	 handle := hnd
	 efox__window_hash_table.put(Current, hashkey)
      end
   
   
feature {ANY} -- event handler
   
   
   on_command: PROCEDURE[ANY,TUPLE] is
	 -- Action that is invoked when the user clicks the button
      require
	 not is_zombie
      do
	 result ?= find_callback_agent(On_command_event)
      end
   
   
   set_on_command (action: PROCEDURE[ANY,TUPLE]) is
	 -- Sets a new handler for the 'on_command' event.
      require
	 not is_zombie
      do
	 set_callback_agent(On_command_event,action)
      end
   
   
feature {ANY} -- properties
      
   
   default_button : BOOLEAN is
	 -- Test if button may become default button when receiving focus.
      require
	 not is_zombie
      do
	 result := efox_button__default_button(handle)
      end
   
   
   set_default_button (flag: BOOLEAN) is
	 -- Mark button as default.
      require
	 not is_zombie
      do
	 efox_button__set_default_button(handle,flag)
      end
   
   
   toolbar_style : BOOLEAN is
	 -- Test if button is drawn in toolbar style.
      require
	 not is_zombie
      do
	 result := efox_button__toolbar_style(handle)
      end
   
   
   set_toolbar_style (flag: BOOLEAN) is
	 -- Set/Remove toolbar style for drawing.
      require
	 not is_zombie
      do
	 efox_button__set_toolbar_style(handle, flag)
      end
   
   
feature {NONE} -- private C binding
   
   
   efox__callback_command(idx: INTEGER; state: BOOLEAN; obj: ANY) is
      local
	 a: PROCEDURE[ANY,TUPLE]
      do
	 a := find_callback_agent(On_command_event)
	 if a /= Void then
	    a.call([])
	 end
      end
   
   efox_button__make(this:like Current; hnd,n,keyptr: POINTER; flag: BOOLEAN) : POINTER is
      external "C"
      end   
   
   efox_button__set_toolbar_style(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox_button__toolbar_style(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_button__set_default_button(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox_button__default_button(hnd: POINTER) : BOOLEAN is
      external "C"
      end

end
   
