class AGUI_CHECK_BUTTON
   
   
inherit
   AGUI_LABEL_BASE
      redefine
	 efox__callback_command
      end
   
   
creation
   {ANY} make
   

feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_check_button__make(Current,p.handle,n.to_external,$temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end


feature {ANY}  -- event handler
   
   
   on_command: PROCEDURE[ANY,TUPLE[BOOLEAN]] is
	 -- Agent that is called when the user clicks the button.
	 -- The argument is 'true' if the button is now checked.
      require
	 not is_zombie
      do
	 result ?= find_callback_agent(On_command_event)
      end
   
   
   set_on_command (action: PROCEDURE[ANY,TUPLE[BOOLEAN]]) is
	 -- Sets the agent for the click action.
      require
	 not is_zombie
      do
	 set_callback_agent(On_command_event, action)
      end
   
   
feature {ANY}
   
   
   checked : BOOLEAN is
	 -- Test if button is checked.
      require
	 not is_zombie
      do
	 result := efox_check_button__checked(handle)
      end   
   
   
   set_checked (new_value: BOOLEAN) is
	 -- Set checked/unchecked mode of button.
      require
	 not is_zombie
      do
	efox_check_button__set_checked(handle,new_value)
      end
   

feature {ANY} -- Appearance properties
   
   
   check_color : AGUI_COLOR is
	 -- Retrieve color for check marker.
      require
	 not is_zombie
      do
	 result.from_integer(efox_check_button__check_color(handle))
      end
   
   
   set_check_color (col: AGUI_COLOR) is
      -- Give the check marker a new color.
      require
	 not is_zombie
      do
	 efox_check_button__set_check_color(handle, col.to_integer)
      end    


feature {NONE} -- private C binding
   
   
   efox__callback_command(idx: INTEGER; state: BOOLEAN; obj: ANY) is
      local
	 a: PROCEDURE[ANY,TUPLE[BOOLEAN]]
      do
	 a ?= find_callback_agent(On_command_event)	 
	 if a /= Void then
	    a.call([state])
	 end
      end
   
   efox_check_button__make(this:like Current; hnd,n,key: POINTER) : POINTER is
      external "C"
      end   
   
   efox_check_button__check_color (hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_check_button__set_check_color (hnd: POINTER; col: INTEGER) is
      external "C"
      end
   
   efox_check_button__set_checked(hnd: POINTER; v: BOOLEAN) is
      external "C"
      end

   efox_check_button__checked(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
end
   
   
