class AGUI_CLIENT_CONTROL
   
   
inherit
   AGUI_BASE_CLIENT_CONTROL
      end
   
creation
   {ANY} make
   
   
feature {ANY}   -- display contents
   
   
   invalidate (x,y,w,h: INTEGER) is
	 -- Marks the given area as dirty.
      do
	 efox_client_control__invalidate(handle, x,y,w,h)
      end
   
   
   set_default_height (h: INTEGER) is
	 -- Set the recommended 'height' of the window.
	 -- This is only a hint.
      do
	 efox_client_control__set_default_height(handle, h)
      end
   
   
   set_default_width (w: INTEGER) is
	 -- Set the recommended 'width' of the window.
	 -- This is only a hint.
      do
	 efox_client_control__set_default_width(handle, w)
      end


feature {NONE} -- constructor
   
    
   make (p: AGUI_COMPOSITE;  n: STRING) is
      do
	 handle := efox_client_control__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
	 create paint_context_private.make
      end
   
      
feature {NONE} -- private C binding
   
   
   efox_client_control__make (this:like Current; hnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end

   efox_client_control__invalidate(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
   efox_client_control__set_default_width(hnd: POINTER; dw: INTEGER) is
      external "C"
      end

   efox_client_control__set_default_height(hnd: POINTER; dw: INTEGER) is
      external "C"
      end

end
   
