class  AGUI_CLIENT_STREAM_SOCKET
   

inherit 
   MEMORY
      redefine dispose
      end


creation
   make
   
   
feature {ANY}
   
   
   connect_to (hostname: STRING; port: INTEGER) is
	 -- Try to establish a socket to the given host.
      do
      end
   
   disconnect is
      -- Close socket.
      do
      end
   
   is_connected : BOOLEAN is
	 -- Test if we have are in a logical connection mode.
	 -- This means that we have issued a 'connect_to' call
	 -- and neither the server closed or refused the connection,
	 -- nor do we have issued a 'disconnect'. In this mode
	 -- we must always call 'disconnect' to avoid a system 
	 -- resource leak.
      do
      end
   
  
   server_port : INTEGER is
	 -- Get server side port number. 
      do
      end
   
   server_hostname : STRING is
	 -- Get server side hostname.
      do
      end
   
   
   last_error_code : INTEGER is
	 -- Returns a operating system dependent code number why
	 -- the socket operation failed. After a failure a socket is
	 -- always disconnected.
      do
      end
   
   last_error_message : STRING is
	 -- Returns a human readable message related to the last
	 -- error code.
      require
	 last_error_code /= 0 
      do
      end
   
   
feature {ANY}  
   
   
   received : STRING
	 -- Keeps the accumulated output text
   
   
   feed_data (data: STRING) is
	 -- Feed the 'data' in string to the server
      require
	 data /= Void
      do
      end
   
   
   set_connected_agent (action: ROUTINE[ANY, TUPLE]) is
	 -- The agent is called when the establish phase of a
	 -- connection to the server either refused or succeded.  
      do
      end
   
   
   set_receive_agent (action: ROUTINE[ANY,TUPLE[INTEGER]]) is
	 -- Sets the method that will be called whenever new data
	 -- is available.  The argument is the number of bytes 
	 -- that is written to the 'received' string. 
	 -- The bytes are already appended to 'received'.
      do
      end
   
   
   set_terminate_agent (action: ROUTINE[ANY,TUPLE]) is
	 -- Sets the agent that is executed whenever the connection 
	 -- is closed by the server or timed out.
      do
      end
   
   
feature {NONE} -- constructor
   
   
   make is
      do
      ensure
	 not is_connected
      end
   

feature {NONE}  -- private section   
   
   
   dispose is
      do
	 efox_process__dispose(handle)
      end
   
end
