deferred class AGUI_CONTROL
   

inherit
   AGUI_WINDOW
      end
   
   
feature {ANY}  -- enable state
   
   
   enabled : BOOLEAN is
	 -- Test if control is enabled.
      require
	 not is_zombie
      do
	 result := efox_imp_window__enabled(handle)
      end
   
   
   set_enabled (flag: BOOLEAN) is
	 -- Set if this control allows input from the user.
      require
	 not is_zombie
      do
	 efox_imp_window__set_enabled(handle,flag)
      end
   
   
feature {ANY} -- help text and tooltip help
   
   
   set_help_text (str: STRING) is
	 -- Sets the help text message.
      require
	 not is_zombie
	 str /= Void
      do	 
	 efox_imp_window__set_help_text(handle, str.to_external)
      end
   
   
   help_text : STRING is
	 -- Returns a new string with the help text message.
      require
	 not is_zombie
      do
	 create result.from_external_copy(efox_imp_window__get_help_text(handle))
      ensure
	 result /= Void
      end
   
   
   set_tooltip_text (str: STRING) is
	 -- Sets the tool tip message.
      require
	 not is_zombie
	 str /= Void
      do
	 efox_imp_window__set_tooltip_text(handle, str.to_external)
      end
   
   
   tooltip_text : STRING is
	 -- Returns a new string with the tooltip message.
      require
	 not is_zombie
      do
	 create result.from_external_copy(efox_imp_window__get_tooltip_text(handle))
      ensure
	 result /= Void
      end
   
   
feature {ANY}
   
   
   efox_imp_window__set_help_text(hnd,str: POINTER) is
      external "C"
      end
         
   efox_imp_window__get_help_text(hnd: POINTER) : POINTER is
      external "C"
      end
  
   efox_imp_window__set_tooltip_text(hnd,str: POINTER) is
      external "C"
      end
   
   efox_imp_window__get_tooltip_text(hdn: POINTER) : POINTER is
      external "C"
      end
      
   efox_imp_window__enabled (hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_imp_window__set_enabled (hnd: POINTER; flag: BOOLEAN) is
      external "C"
      end
   
   
end
   
