class  AGUI_CURSOR
   
inherit
   AGUI_GLOBALS
      end
   
   
creation
   {AGUI_CURSOR_MANAGER} make
   
   
feature {ANY}
   
   
   name : STRING is
	 -- new created string with registered name of icon.
      require
	 not is_zombie
      do
	 create result.from_external_copy(efox_cursor__name(handle))
      ensure
	 name /= Void
	 name.count > 0
      end
   
   
   width : INTEGER
	 -- width of icon in pixel
   
   height : INTEGER
	 -- height of icon in pixel
   
   hotspot_x : INTEGER
	 -- return hotspot x coordinate
   
   hotspot_y : INTEGER
	 -- return hotspot y coordinate
   
   
   is_zombie : BOOLEAN
	 -- is icon already destroyed
   
   destroy is
	 -- Destroy the cursor. This means you can't use it anymore and
	 -- it will be physical removed when the last reference goes away.
	 -- You can't destroy a stock cursor.
      require
	 not is_zombie
	 not is_stock_cursor
      do
	 efox_cursor__destroy(Current,handle)
	 is_zombie := true
      ensure
	 is_zombie
      end
   
   
   is_stock_cursor : BOOLEAN is
	 -- Test if it is a predefined cursor.
      require
	 not is_zombie
      do
	 result := efox_cursor__is_stock_cursor(handle)
      end
   
   
feature {ANY}  -- required access to internal data
   
   handle : POINTER
	 -- handle to an 'efox_icon' data structure
   
feature {NONE} -- private section
   
   
   make (hnd: POINTER; w,h,hx,hy: INTEGER) is
      do
	 handle := hnd
	 width := w
	 height := h
	 hotspot_x := hx
	 hotspot_y := hy
      end
   
   efox_cursor__is_stock_cursor (hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_cursor__name(hnd: POINTER) : STRING is
      external "C"
      end
   
   efox_cursor__destroy(this:like Current; hnd: POINTER) is
      external "C"
      end
   

end




   
   
