class  AGUI_DIRECTORY_DIALOG

inherit
   AGUI_PREDEFINED_DIALOG
      end
   

creation
   make
   
   
feature {ANY}  -- properties
   
   
   directory : STRING is
	 -- Get directory.
      do
	 create result.from_external_copy(efox_directory_dialog__directory(handle))
      end
   
   
   set_directory (str: STRING) is
	 -- Set default directory.
      do
	 efox_directory_dialog__set_directory(handle, str.to_external)
      end
   
   
feature {NONE} -- Constructor
   
   
   make (owner: AGUI_WINDOW) is
	 -- Create dialog that stays on top of 'owner'.
      require
	 not owner.is_zombie
      do
	 handle := efox_directory_dialog__make(Current,owner.handle,$temp_key)
	 check not efox__window_hash_table.has(temp_key) end
	 efox__window_hash_table.put(Current, temp_key)
      end
   

feature {NONE} -- private C binding
   
   
   efox_directory_dialog__make(this:like Current; ptr,keyptr: POINTER) : POINTER is
      external "C"
      end
      
   efox_directory_dialog__directory(h: POINTER) : POINTER is
      external "C"
      end
			    
   efox_directory_dialog__set_directory(h,p: POINTER) is
      external "C"
      end
   
end   
