class  AGUI_DRAG_CORNER
   
   
inherit
   AGUI_WINDOW
   end
   
   
creation
   {ANY} make

creation 
   {AGUI_APPLICATION} make_internal
   
   
feature {ANY} -- appearance properties
   
   
   set_highlight_color (col: AGUI_COLOR) is
      do
	 efox_drag_corner__set_highlight_color(handle, col.to_integer)
      end
   
   
   highlight_color : AGUI_COLOR is
      do
	 result.from_integer(efox_drag_corner__highlight_color(handle))
      end
   
   
   set_shadow_color (col: AGUI_COLOR) is
      do
	 efox_drag_corner__set_shadow_color(handle, col.to_integer)
      end
   
   
   shadow_color : AGUI_COLOR is
      do
	 result.from_integer(efox_drag_corner__shadow_color(handle))
      end
   
   
feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_drag_corner__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
   make_internal (hashkey: INTEGER; hnd: POINTER) is
      require
	 hnd /= default_pointer
      do
	 handle := hnd
	 efox__window_hash_table.put(Current, hashkey)
      end
   
   
feature {NONE} -- private C binding
   
      
   efox_drag_corner__make(this:like Current; hnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end   

   efox_drag_corner__set_highlight_color (hnd: POINTER; col: INTEGER) is
      external "C"
      end
   
   efox_drag_corner__highlight_color(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_drag_corner__set_shadow_color (hnd: POINTER; col: INTEGER) is
      external "C"
      end
   
   efox_drag_corner__shadow_color(hnd: POINTER) : INTEGER is
      external "C"
      end
   

end
