expanded class  AGUI_EVENT_CONSTANTS
   
   
feature {ANY}   -- modifier bits
   
   Alt : INTEGER is 29
   Control : INTEGER is 30
   Shift : INTEGER is 32   
   
   Num_lock : INTEGER is 28
   Scroll_lock : INTEGER is 27
   Caps_lock : INTEGER is 31

   Left_button : INTEGER is 24
   Middle_button : INTEGER is 23
   Right_button : INTEGER is 22
   

feature {ANY}   -- special key symbols
   
   Key_cursor_home : INTEGER is 65360
   Key_cursor_left : INTEGER is 65361
   Key_cursor_up : INTEGER is 65362
   Key_cursor_right : INTEGER is 65363
   Key_cursor_down : INTEGER is 65364
   Key_cursor_page_up : INTEGER is 65365
   Key_cursor_page_down : INTEGER is 65366
   Key_cursor_end : INTEGER is 65367
   Key_cursor_begin : INTEGER is 65370      --- TODO right code ??

   Key_tab : INTEGER is 65289
   Key_enter : INTEGER is 65293 
   Key_delete : INTEGER is 65535
   Key_insert : INTEGER is 65379
   Key_backspace : INTEGER is 65288
   Key_escape : INTEGER is 65307
   Key_space : INTEGER is 32
   
   Key_function_1 : INTEGER is 65470
   Key_function_2 : INTEGER is 65471
   Key_function_3 : INTEGER is 65472
   Key_function_4 : INTEGER is 65473
   Key_function_5 : INTEGER is 65474
   Key_function_6 : INTEGER is 65475
   Key_function_7 : INTEGER is 65476
   Key_function_8 : INTEGER is 65477
   Key_function_9 : INTEGER is 65478
   Key_function_10 : INTEGER is 65479
   Key_function_11 : INTEGER is 65480
   Key_function_12 : INTEGER is 65481
   
   Key_shift_left : INTEGER is 65505
   Key_shift_right : INTEGER is 65506
   Key_control_left : INTEGER is 65507
   Key_control_right : INTEGER is 65508
   Key_caps_lock : INTEGER is 65509
   Key_shift_lock : INTEGER is 65510
   Key_meta_left : INTEGER is 65511
   Key_meta_right : INTEGER is 65512
   Key_alt_left : INTEGER is 65513
   Key_alt_right : INTEGER is 65514
      
   
   code_for_special_key (name: STRING) : INTEGER is
      local
	 i,n: INTEGER
	 a : ARRAY[STRING]
      do
	 from
	    a := special_key_names
	    i := a.lower
	    n := a.upper
	 until
	    i > n or else result /= 0
	 loop
	    if a.item(i).same_as(name) then
	       result := special_key_values.item(i)
	    end
	    i := i + 1
	 end
      end
   
   name_for_special_key (code: INTEGER) : STRING is
      local
	 i,n: INTEGER
	 a : ARRAY[INTEGER]
      do
	 from
	    a := special_key_values
	    i := a.lower
	    n := a.upper
	 until
	    i > n or else result /= Void
	 loop
	    if a.item(i) = code then
	       result := clone(special_key_names.item(i))
	    end
	    i := i + 1
	 end	    
      end
   
   is_modifier_key (code: INTEGER) : BOOLEAN is
      do
	 --TODO why is the keycode so big ????
	 result := (code >= Key_shift_left and then code <= Key_alt_right) or else code > 65535	 
      end
   
   
feature {NONE}
   
   
   special_key_names : ARRAY[STRING] is
      once
	 result := << "Home", "Left", "Up", "Right", "Down", "PageUp", "PageDown",
		      "End", "Begin", "Tab", "Enter", "Delete", "Insert",
		      "Backspace", "Escape", "F1", "F2", "F3", "F4",
		      "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12" 
		      "ShiftLeft", "ShiftRight", "ControlLeft", "ControlRight",
		      "CapsLock", "ShiftLock", "MetaLeft", "MetaRight", 
		      "AltLeft", "AltRight", "Space"
		   >>
      end
   
   
   special_key_values : ARRAY[INTEGER] is
      once
	 result := << Key_cursor_home, Key_cursor_left, Key_cursor_up,
		      Key_cursor_right, Key_cursor_down, Key_cursor_page_up,
		      Key_cursor_page_down, Key_cursor_end, Key_cursor_begin,
		      Key_tab, Key_enter, Key_delete, Key_insert,
		      Key_backspace, Key_escape, Key_function_1,
		      Key_function_2, Key_function_3, Key_function_4,
		      Key_function_5, Key_function_6, Key_function_7,
		      Key_function_8, Key_function_9, Key_function_10,
		      Key_function_11, Key_function_12,
		      
		      Key_shift_left, Key_shift_right,
		      Key_control_left, Key_control_right,
		      Key_caps_lock, Key_shift_lock,
		      Key_meta_left, Key_meta_right,
		      Key_alt_left, Key_alt_right, Key_space,	      
		      >>
      end
   
end
   
