class  AGUI_EXPANDED_LIST_BASE_ITEM
   

inherit
   AGUI_LIST_BASE_ITEM
      end
   
   
feature {ANY}  -- queries
   
   
   selected : BOOLEAN is
	 -- Test if item is selected.
      require
	 not is_zombie
      do
	 result := efox_expanded_list_base_item__selected (handle,list_kind)
      end
   
   
   set_selected (flag: BOOLEAN) is
	 -- Set select mode of item.
      require
	 not is_zombie
      do
	 efox_expanded_list_base_item__set_selected (handle,list_kind, flag)
      end
   
   
   draggable : BOOLEAN is
	 -- Test if item is draggable.
      require
	 not is_zombie
      do
	 result := efox_expanded_list_base_item__draggable (handle,list_kind)
      end
   
   
   set_draggable (flag: BOOLEAN) is
	 -- Marks or unmarks the item as draggable.
      require
	 not is_zombie
      do
	 efox_expanded_list_base_item__set_draggable (handle,list_kind,flag)
      end
   
   
   enabled : BOOLEAN is
	 -- Test if item is enabled or disabled. 
      require
	 not is_zombie
      do
	 result := efox_expanded_list_base_item__enabled (handle,list_kind)
      end
   
   
   set_enabled (flag: BOOLEAN) is
	 -- Make item enabled or disabled. Disabled items can't be selected.
      require
	 not is_zombie
      do
	 efox_expanded_list_base_item__set_enabled(handle,list_kind, flag)
      end

   
feature {ANY} -- Visibility control
   
   
   is_visible : BOOLEAN is
	 -- Test if item is visible.
      require 
	 not is_zombie
      do
	 result := efox_expanded_list_base_item__is_visible(handle, list_kind)
      end
   
   
   make_visible is
	 -- Scroll to make item visible.
      require	 
	 not is_zombie
      do
	 efox_expanded_list_base_item__make_visible(handle, list_kind)
      end
   

feature {NONE} -- private C binding


   efox_expanded_list_base_item__selected(hnd: POINTER; listkind: INTEGER) : BOOLEAN is
      external "C"
      end

   efox_expanded_list_base_item__set_selected(hnd: POINTER; listkind: INTEGER; flag: BOOLEAN) is
      external "C"
      end

   efox_expanded_list_base_item__draggable(hnd: POINTER; listkind: INTEGER) : BOOLEAN is
      external "C"
      end

   efox_expanded_list_base_item__set_draggable(hnd: POINTER; listkind: INTEGER; flag: BOOLEAN) is
      external "C"
      end

   efox_expanded_list_base_item__enabled (hnd: POINTER; lk: INTEGER) : BOOLEAN is
      external "C"
      end
   
   
   efox_expanded_list_base_item__set_enabled(hnd: POINTER; lk: INTEGER; flag: BOOLEAN) is
      external "C"
      end
   
   efox_expanded_list_base_item__is_visible(hnd: POINTER; listkind: INTEGER) : BOOLEAN is
      external "C"
      end

   efox_expanded_list_base_item__make_visible(hnd: POINTER; listkind: INTEGER) is
      external "C"
      end
   
   
end
