class  AGUI_FONT
      
creation
   {AGUI_FONT_MANAGER} make
   
   
feature {ANY}
   
   
   height : INTEGER
   ascend : INTEGER
   descent : INTEGER
   spacing : INTEGER   
	 
	 
   is_proportional_font : BOOLEAN is
      do
	 result := efox_font__is_proportional_font(handle)
      end
   
   
   measure_string (s: STRING) : INTEGER is
      require
	 not is_zombie
	 s /= Void
      do
	 result := efox_font__measure_string(handle, s.to_external, s.count)
      ensure
	 result >= 0
      end
   
   measure_substring (s: STRING; aidx,eidx: INTEGER) : INTEGER is
      require
	 not is_zombie
	 s /= Void
	 aidx <= eidx+1
      do
	 result := efox_font__measure_substring(handle, s.to_external, aidx, eidx)
      ensure
	 result >= 0
      end
	
   
   
   
   name : STRING is 
	 -- new created string with the registered name of the font
      require
	 not is_zombie
      do
	 result := clone(efox_font__name(handle))
      ensure
	 name /= Void
	 name.count > 0
      end


   is_zombie : BOOLEAN is
	 -- is font already destroyed
      do
	 result := handle = default_pointer
      end
      
   destroy is
      require
	 not is_zombie
      do
	 efox_font__destroy(Current,handle)
	 handle := default_pointer
      ensure
	 is_zombie
      end
   
   
feature {ANY}  -- required access for output
   
   
   handle : POINTER
	 -- pointer to the FXFont object (a handle to the efox_font
	 -- object is available from there via the getUserData method.
   
feature {NONE} -- private section
   
   
   make (hnd: POINTER) is
      do
	 handle := hnd;
	 efox_font__efox_query_properties(handle, $height, $ascend, $descent, $spacing)
      end
   
   
   efox_font__name(hnd: POINTER) : STRING is
      external "C"
      end
   
   efox_font__destroy(this:like Current; hnd: POINTER) is
      external "C"
      end
   
   efox_font__efox_query_properties(hnd,h,a,d,s: POINTER) is
      external "C"
      end
      
   efox_font__is_proportional_font(hnd: POINTER): BOOLEAN is
      external "C"
      end
   
   efox_font__measure_string(hnd,str: POINTER; n:INTEGER) : INTEGER is
      external "C"
      end
   
   efox_font__measure_substring(hnd,str: POINTER; a,e: INTEGER) : INTEGER is
      external "C"
      end
   
   
end   
