deferred class  AGUI_FRAME_MIXIN
   
inherit
   AGUI_MIXIN
      end
   
   
feature {ANY}  --- frame options
   
   
   Frame_none     : INTEGER is 0
   Frame_sunken   : INTEGER is 1
   Frame_raised   : INTEGER is 2
   Frame_groove   : INTEGER is 3
   Frame_ridge    : INTEGER is 4
   Frame_solid    : INTEGER is 5   
   
   
   set_frame_style (n: INTEGER; thick: BOOLEAN) is
	 -- Change the frame style. The 'thick' parameter 
	 -- is only used in 'Frame_sunken' and 'Frame_raised'
	 -- mode.
      require
	 not mixin_window.is_zombie
	 n.in_range(Frame_none, Frame_solid)
      do
	 efox_imp_window__set_frame_style(mixin_window.handle, n, thick)
      end
      
   
   set_frame_color (base: AGUI_COLOR) is
	 -- Set the frame colors. Only the base color is 
	 -- specified directly, all other colors are choosen
	 -- correlated to this base color.
      require
	 not mixin_window.is_zombie
      do
	 efox_imp_window__set_frame_color(mixin_window.handle, base.to_integer)
      end
   
   
   set_frame_colors (shadow, hilite, base, border: AGUI_COLOR) is
	 -- Set the frame color by specifiying all colors
	 -- individually.
      require
	 not mixin_window.is_zombie
      do
	 efox_imp_window__set_frame_colors(mixin_window.handle, shadow.to_integer, hilite.to_integer, base.to_integer, border.to_integer)
      end
   
   
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- Window in that this class is mixed in.
      deferred
      end
   
   
feature {NONE} --- private
   
   
   efox_imp_window__set_frame_style(hnd: POINTER; n: INTEGER; thick: BOOLEAN) is
      external "C"
      end
      
   efox_imp_window__set_frame_colors(hnd: POINTER; col1,col2,col3,col4: INTEGER) is
      external "C"
      end
   
   efox_imp_window__set_frame_color(hnd: POINTER; col1: INTEGER) is
      external "C"
      end
   
end
