class  AGUI_GROUPBOX
   

inherit
   AGUI_PACKER
      rename make as make_packer
      end
   
   
creation
   {ANY} make
   

feature {NONE} -- constructor

   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 not p.is_zombie	 
      do
	 handle := efox_group_box__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
	 set_frame_style(Frame_ridge)
      end
   
   
feature {ANY}  -- public features
   
   
   set_text (str: STRING) is
      require
	 not is_zombie
	 str /= void
      do
	 efox_group_box__set_title(handle,str.to_external)	 
      end
   
   
   text : STRING is
      -- return a new string with title of the group box
      require
	 not is_zombie
      do
	 create result.from_external_copy(efox_group_box__title(handle))
      ensure
	 text /= Void
      end
   
   
feature {ANY} -- Groupbox style
   
   
   Groupbox_title_left : INTEGER is 0
	 -- Title is left-justified
   
   Groupbox_title_right : INTEGER is 1
	 -- Title is right-justified
  
   Groupbox_title_center : INTEGER is 2
	 -- Title is centered
   
   
   style : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_group_box__style (handle)
      end      
   
   
   set_style (n: INTEGER) is
      require
	 not is_zombie
	 n.in_range(Groupbox_title_left, Groupbox_title_center)
      do
	 efox_group_box__set_style(handle,n)
      end
   
   
feature {ANY}  --  Appearance features   
   
   
   font : AGUI_FONT is
      require
	 not is_zombie
      do
	 result := efox_group_box__font(handle)
      ensure
	 result /= Void
      end
   
   
   set_font (f: AGUI_FONT) is
      require
	 not is_zombie
	 f /= Void and then not f.is_zombie
      do
	 efox_group_box__set_font(handle, f.handle)
      end
   
   
   set_text_color (col: AGUI_COLOR) is
      require
	 not is_zombie
      do
	 efox_group_box__set_text_color(handle, col.to_integer)
      end
   
   
   text_color : AGUI_COLOR is
      require
	 not is_zombie
      do
	 result.from_integer(efox_group_box__text_color(handle))
      end
   
     
feature {NONE} -- private C binding
   
   
   efox_group_box__make (this:like Current; hnd,n: POINTER) : POINTER is
      external "C"
      end
	 
   efox_group_box__font(hnd: POINTER) : AGUI_FONT is
      external "C"
      end
   
   efox_group_box__set_font(hnd,fhnd: POINTER) is
      external "C"
      end
   
   efox_group_box__text_color(hnd: POINTER) : INTEGER is
      external "C"
      end	 
	 
   efox_group_box__set_text_color(hnd: POINTER; col: INTEGER) is
      external "C"
      end
      
   efox_group_box__set_title (hnd,str: POINTER) is
      external "C"
      end
	 
   efox_group_box__title (hnd: POINTER) : POINTER is
      external "C"
      end

   efox_group_box__set_style (hnd: POINTER; n: INTEGER) is
      external "C"
      end

   efox_group_box__style (hnd: POINTER) : INTEGER is
      external "C"
      end

end
