deferred class  AGUI_HEADER_MIXIN
   
   
inherit
   AGUI_MIXIN
      end
   
   
feature  {ANY} --  header operations

   
   clear_columns is
      require
	 not mixin_window.is_zombie
      do
	 efox_header_mixin__clear_columns(mixin_window.handle)
      end

   
   append_column(str: STRING; cwidth: INTEGER) is
      require
	 not mixin_window.is_zombie
	 str /= Void
	 cwidth >= 0
      do
	 efox_header_mixin__append_column(mixin_window.handle, str.to_external, cwidth)
      end
   
   
   remove_column(idx: INTEGER) is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
      do
	 efox_header_mixin__remove_column(mixin_window.handle,idx)
      end
   
   
   count_columns : INTEGER is
      require
	 not mixin_window.is_zombie
      do
	 result := efox_header_mixin__count_columns(mixin_window.handle)
      ensure
	  result >= 0
      end


   set_column_text (idx: INTEGER; str: STRING) is
      require
	 not mixin_window.is_zombie
	 str /= Void
	 idx.in_range(1,count_columns)
      do
	 efox_header_mixin__set_column_text(mixin_window.handle, idx, str.to_external)
      end

   
   column_text (idx: INTEGER) : STRING is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
      do
	 create result.from_external_copy(efox_header_mixin__column_text(mixin_window.handle,idx))
      ensure
	 result /= Void
      end


   set_column_icon (idx: INTEGER; icon: AGUI_ICON) is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
	 icon /= Void implies not icon.is_zombie
      local
	 ic : POINTER
      do
	 if icon /= Void then ic := icon.handle end
	 efox_header_mixin__set_column_icon(mixin_window.handle,idx,ic);
      end
   
   
   column_icon (idx: INTEGER) : AGUI_ICON is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
      do
	 result := efox_header_mixin__column_icon(mixin_window.handle,idx)
      end

   
   set_column_width (idx: INTEGER; cwidth: INTEGER) is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
	 cwidth >= 0
      do
	 efox_header_mixin__set_column_width(mixin_window.handle,idx,cwidth);
      end
   
   
   column_width (idx: INTEGER) : INTEGER is
      require
	 not mixin_window.is_zombie
	 idx.in_range(1,count_columns)
      do
	 result := efox_header_mixin__column_width(mixin_window.handle,idx)
      end
   
   
   set_header_button_mode (flag: BOOLEAN) is
      require
	 not mixin_window.is_zombie
      do
	 efox_header_mixin__set_button_mode(mixin_window.handle, flag)
      end
   
   header_button_mode : BOOLEAN is
      require
	 not mixin_window.is_zombie
      do
	 result := efox_header_mixin__button_mode(mixin_window.handle)
      end
	 
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- Window in that this class is mixed in.
      deferred
      end
   

feature {NONE} -- private C binding
   
   
   efox_header_mixin__clear_columns(hnd: POINTER) is
      external "C"
      end

   efox_header_mixin__append_column(hnd,str: POINTER; cwidth: INTEGER) is
      external "C"
      end

   efox_header_mixin__remove_column(hnd: POINTER; idx:INTEGER) is
      external "C"
      end
   
   efox_header_mixin__count_columns(hnd: POINTER) : INTEGER is
      external "C"
      end

   efox_header_mixin__set_column_text(hnd: POINTER; idx:INTEGER; str: POINTER) is
      external "C"
      end

   efox_header_mixin__column_text(hnd: POINTER; idx: INTEGER) : POINTER is
      external "C"
      end

   efox_header_mixin__set_column_icon(hnd: POINTER; idx: INTEGER; ic: POINTER) is
      external "C"
      end

   efox_header_mixin__column_icon(hnd: POINTER; idx: INTEGER) : AGUI_ICON is
      external "C"
      end

   efox_header_mixin__column_width(hnd: POINTER; idx: INTEGER) : INTEGER is
      external "C"
      end

   efox_header_mixin__set_column_width(hnd: POINTER; idx,cwidth: INTEGER) is
      external "C"
      end
   
   efox_header_mixin__set_button_mode(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox_header_mixin__button_mode(hnd: POINTER) : BOOLEAN is
      external "C"
      end

end   
