deferred class  AGUI_LABEL_BASE
   

--TODO visual size


-- The packer mixin ignores the packing hints and the
-- spacing because a label can't have child windows.
   
   
   
inherit
   AGUI_CONTROL
      end
   AGUI_FRAME_MIXIN
      redefine mixin_window
      end
   AGUI_PACKER_MIXIN
      redefine mixin_window
      end
   
   

feature {ANY}
   
   
   Icon_before_text : INTEGER is 0
   Icon_after_text : INTEGER is 1
   Icon_above_text : INTEGER is 2
   Icon_below_text : INTEGER is 3
   Icon_under_text : INTEGER is 4
   
   
   text : STRING is
      require
	 not is_zombie
      do
	 create result.from_external_copy(efox_label_base__text(handle))
      ensure
	 result /= Void
      end
   
   set_text (new_value: STRING) is
      require
	 not is_zombie
	 new_value /= Void
      do
	 efox_label_base__set_text(handle, new_value.to_external)
      end
   
   
   icon : AGUI_ICON is
      require
	 not is_zombie
      do
	 result := efox_label_base__icon(handle)
      end
   
   set_icon (new_value: AGUI_ICON) is
      require
	 not is_zombie
	 new_value /= Void implies not new_value.is_zombie
      local
	 p : POINTER
      do
	 if new_value /= Void then p := new_value.handle end
	 efox_label_base__set_icon(handle, p)
      end
   
   
   icon_position : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_label_base__icon_position(handle)
      end
	 
   
   set_icon_position (pos: INTEGER) is
      require
	 not is_zombie
	 pos.in_range(Icon_before_text, Icon_under_text)
      do
	 efox_label_base__set_icon_position(handle,pos)
      ensure
	 icon_position = pos
      end
   

feature {ANY} -- appearance properties
   
   
   font : AGUI_FONT is
      require
	 not is_zombie
      do
	 result := efox_label_base__font(handle)
      end
   
   
   set_font (f: AGUI_FONT) is
      require
	 not is_zombie
	 f /= Void
	 not f.is_zombie
      do
	 efox_label_base__set_font(handle, f.handle)
      end
   
   
   set_text_color (col: AGUI_COLOR) is
      require
	 not is_zombie
      do
	 efox_label_base__set_text_color(handle, col.to_integer)
      end
   
   
   text_color : AGUI_COLOR is
      require
	 not is_zombie
      do
	 result.from_integer(efox_label_base__text_color(handle))
      end
   
  
   Justify_center_x : INTEGER is 0
   Justify_left : INTEGER is 32768
   Justify_right : INTEGER is 65536
   Justify_horizontal_apart : INTEGER is 98304
   
   Justify_center_y : INTEGER is 0   
   Justify_top : INTEGER is 131072
   Justify_bottom  : INTEGER is 262144
   Justify_vertical_apart : INTEGER is 393216
      
   
   set_justify (mode: INTEGER) is
      require
	 not is_zombie
      do
	 efox_label_base__set_justify(handle, mode)
      end
   
   
   justify : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_label_base__justify(handle)
      end
   
   
feature {ANY} -- event handling
   
   
   invoke is
	 -- This method has the same effect as if the user presses 
	 -- the mouse on this button. The Button will change its 
	 -- state and the on_command handler will be triggered.
      do
	 efox_label_base__invoke(handle)
      end
   
      
feature {ANY}  -- mixin configure
   
   
   mixin_window : AGUI_WINDOW is
	 -- redefine the mixin window references to this window
      do
	 result := Current
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_label_base__font(hnd: POINTER) : AGUI_FONT is
      external "C"
      end
   
   efox_label_base__set_font(hnd,fhnd: POINTER) is
      external "C"
      end
   
   efox_label_base__set_justify(hnd: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_label_base__justify(hnd: POINTER) : INTEGER is
      external "C"
      end	 
	 
   efox_label_base__text_color(hnd: POINTER) : INTEGER is
      external "C"
      end	 
	 
   efox_label_base__set_text_color(hnd: POINTER; col: INTEGER) is
      external "C"
      end
   
   efox_label_base__set_icon_position (hnd: POINTER; ipos: INTEGER) is
      external "C"
      end
   
   efox_label_base__icon_position (hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_label_base__text(hnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_label_base__set_text(hnd, str: POINTER) is
      external "C"
      end
   
   efox_label_base__set_icon(hnd, ihnd: POINTER) is
      external "C"
      end
   
   efox_label_base__icon(hnd: POINTER) : AGUI_ICON is
      external "C"
      end
   
   efox_label_base__invoke(hnd: POINTER) is
      external "C"
      end   
   
end



   
