class  AGUI_LIST
   

inherit
   AGUI_EXPANDED_LIST_BASE
      redefine item_type
      end
   
   
creation
   make
   
   
feature {ANY}
   
   item_type : AGUI_LIST_ITEM
   
   
feature {ANY}  -- queries


   hit (x,y: INTEGER) : INTEGER is
	 -- Return  item hit code: 0 outside, 1 icon, 2 text, 3 box
      require
	 not is_zombie
      do
	 result := efox_list__hit(handle,x,y)
      end
   

feature {ANY}  -- mixin configure
   
   
   mixin_window : AGUI_WINDOW is
	 -- redefine the mixin window references to this window
      do
	 result := Current
      end
   

feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_list__make(Current,p.handle,n.to_external,$temp_px)
	 efox__window_hash_table.put(Current, temp_px)
	 create item_dict.with_capacity(100)
      end
   

feature {NONE} -- private C binding
   
   
   efox__callback_destroy_item (i: AGUI_LIST_ITEM; key: INTEGER) is
      do
	 check item_dict.has(key) end
	 item_dict.remove(key)
	 i.mark_zombie
      end
   
   efox_list__hit(hnd: POINTER; x,y: INTEGER) : INTEGER is
      external "C"
      end   
    
   efox_list__make(this:like Current; hnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end   
   
end
