class  AGUI_LIST_BOX
   

inherit
   AGUI_LIST_BASE
      redefine item_type
      end
   AGUI_PACKER_MIXIN
      end
   
   
creation
   make
   
   
feature {ANY}
   
   item_type : AGUI_LIST_BOX_ITEM
   
   
feature {ANY} -- 
   
   
   number_of_visible_items : INTEGER is
      do
	 result := efox_list_box__number_of_visible_items(handle)
      end
   
   set_number_of_visible_items (n: INTEGER) is
      do
	 efox_list_box__set_number_of_visible_items(handle,n)
      end   
   
   is_popup_shown : BOOLEAN is
      do
	 result := efox_list_box__is_popup_shown(handle)
      end
   
   popup is
      do
	 efox_list_box__popup(handle)
      end
   
   
   mixin_window : AGUI_WINDOW is
	 -- redefine the mixin window references to this window
      do
	 result := Current
      end
   
   
feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_list_box__make(Current,p.handle,n.to_external,$temp_px)
	 check handle /= default_pointer end
	 efox__window_hash_table.put(Current, temp_px)
	 create item_dict.with_capacity(100)
      end
   
   
feature {NONE} -- private C binding
   
   
   efox__callback_destroy_item (i: AGUI_LIST_BOX_ITEM; key: INTEGER) is
      do
	 check item_dict.has(key) end
	 item_dict.remove(key)
	 i.mark_zombie
      end
   
   efox_list_box__make(this:like Current; hnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end   
   
  efox_list_box__set_number_of_visible_items(hnd: POINTER; n: INTEGER) is
      external "C"
      end   
   
   efox_list_box__number_of_visible_items(hnd: POINTER) : INTEGER is
      external "C"
      end   
   
   efox_list_box__is_popup_shown(hnd: POINTER) : BOOLEAN is
      external "C"
      end   
   
   efox_list_box__popup(hnd: POINTER) is
      external "C"
      end   
   
end
