class  AGUI_LIST_ITEM
   

inherit
   AGUI_EXPANDED_LIST_BASE_ITEM
      end


creation
   {ANY} make, make_with_icon


feature {NONE} -- constructor
   
   
   make (list: AGUI_LIST; str: STRING) is
	 -- Create an item and append it to the list.
      require
	 list /= Void and not list.is_zombie
	 str /= Void
      do
	 handle := efox_list_item__make (Current,list.handle, str.to_external, $list_kind)
	 list.item_dict.put(Current, list_kind)
	 list_kind := 3
      end

   
   make_with_icon (list: AGUI_LIST; str: STRING; ic: AGUI_ICON) is
	 -- Create an item with an icon and append it to the list.
      require
	 list /= Void and not list.is_zombie
	 str /= Void
	 ic /= Void implies not ic.is_zombie
      local
	 p : POINTER
      do
	 if ic /= Void then p := ic.handle end
	 handle := efox_list_item__make_with_icon(Current,list.handle, str.to_external, p, $list_kind)
	 list.item_dict.put(Current, list_kind)
	 list_kind := 3
      end

   
feature {AGUI_LIST} 
   
   
   mark_zombie is
      do
	 handle := default_pointer
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_list_item__make (this:like Current; lhnd,str,keyptr: POINTER) : POINTER is
      external "C" 
      end
   
   efox_list_item__make_with_icon (this:like Current; lhnd,str,ic,keyptr : POINTER) : POINTER  is
      external "C" 
      end
   
end


