class  AGUI_MATRIX
   
inherit
   AGUI_PACKER
      rename make as make_packer
      end
   
   
creation
   {ANY} make
   

feature {NONE} -- constructor

   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_matrix__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
feature {ANY} -- properties
   
   
   Matrix_by_columns : INTEGER is 0 
   Matrix_by_rows :    INTEGER is 1
   
   
   matrix_style : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_matrix__matrix_style(handle)
      end
	 
   
   set_matrix_style (style: INTEGER) is
      require
	 not is_zombie
	 style.in_range(Matrix_by_columns, Matrix_by_rows)
      do
	 efox_matrix__set_matrix_style(handle, style)
      ensure
	 matrix_style = style
      end
   
   
   matrix_size : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_matrix__matrix_size(handle)
      end
   
   
   set_matrix_size (n: INTEGER) is
      require
	 not is_zombie
	 n > 0
      do
	 efox_matrix__set_matrix_size(handle, n)
      ensure
	 matrix_size = n
      end
   
   
feature {ANY} -- information about current matrix layout
   
   
   columns : INTEGER is
      do
	 result := efox_matrix__columns(handle)
      end
   
   rows : INTEGER is
      do
	 result := efox_matrix__rows(handle)
      end
   
   row_of_widget (widget: AGUI_WINDOW) : INTEGER is
      require
	 not is_zombie
	 widget /= Void
	 not widget.is_zombie
	 widget.parent_window = Current
      do
	 result := efox_matrix__row_of_widget (handle, widget.handle)
      end
   
   column_of_widget (widget: AGUI_WINDOW) : INTEGER is
      require
	 not is_zombie
	 widget /= Void
	 not widget.is_zombie
	 widget.parent_window = Current
      do
	 result := efox_matrix__column_of_widget (handle, widget.handle)
      end
   
   widget_at_row_column (row,column: INTEGER) : AGUI_WINDOW is
      require
	 not is_zombie
	 row >= 1
	 column >= 1
	 row <= rows
	 column <= columns
      do
	 result := efox_matrix__widget_at_row_column(handle, row,column)
      end
   

feature {NONE} -- private C binding
   
   
   efox_matrix__matrix_style(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_matrix__matrix_size(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_matrix__set_matrix_size(hnd: POINTER; n: INTEGER)is
      external "C"
      end
   
   efox_matrix__set_matrix_style(hnd: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_matrix__columns(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_matrix__column_of_widget (hnd, whnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_matrix__row_of_widget (hnd, whnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_matrix__widget_at_row_column (hnd: POINTER; r,c:INTEGER) : AGUI_WINDOW is
      external "C"
      end
   
   efox_matrix__rows(hnd: POINTER) : INTEGER is
      external "C"
      end      
   
   efox_matrix__make (this:like Current; hnd,n,key: POINTER) : POINTER is
      external "C"
      end	 
   
end
