class  AGUI_MDI_CHILD
   
   
inherit
   AGUI_COMPOSITE
      end
   
creation
   {ANY} make
   
   
feature {ANY}
   
   
   next : AGUI_MDI_CHILD is
      do
	 result := efox_mdi_child__next(handle)
      end
   
   
   set_title (str: STRING) is
      do
	 efox_mdi_child__set_title(str.to_external)
      end
   
   title : STRING is
      do
	 create result.from_external_copy(efox_mdi_child__title(handle))
      end
      
   
   set_color (which: INTEGER; color: AGUI_COLOR) is
      do
	 efox_mdi_child__set_color(handle,which,color.to_integer)
      end
      
   color (which: INTEGER) : AGUI_COLOR is
      do
	 result.from_integer(efox_mdi_child__color(handle,which))
      end
   
   
   set_icon (ic: AGUI_ICON) is
      do
	 efox_mdi_child__set_icon(handle, ic.handle)
      end
   
   icon : AGUI_ICON is
      do
	 result := efox_mdi_child__icon(handle)
      end
   
   set_font (f: AGUI_FONT) is
      do
	 efox_mdi_child__set_font(handle, f.handle)
      end
   
   font : AGUI_FONT is
      do
	 result := efox_mdi_child__font(handle)
      end
   
   
feature {ANY} -- position management
   
   
   move (x,y: INTEGER) is
      do
	 efox_mdi_child__move(handle,x,y)
      end
   
   resize (w,h: INTEGER) is
      do
	 efox_mdi_child__resize(handle,w,h)
      end
   
   position (x,y,w,h: INTEGER) is
      do
	 efox_mdi_child__position(handle,x,yw,h)
      end   
   
      
   maximize is
      do
	 efox_mdi_child__maximize(handle)
      end
   
   minimize is
      do
 	 efox_mdi_child__minimize(handle)
      end   
   
   is_maximized : BOOLEAN is
      do
	 result := efox_mdi_child__is_maximize(handle) 
      end
   
   is_minimized : BOOLEAN is
      do
	 result := efox_mdi_child__is_minimized(handle)
      end
   
   restore is
      do
	 efox_mdi_child__restore(handle)
      end
   
   set_icon_position (x,y,w,h: INTEGER) is
      do
	 efox_mdi_child__set_icon_position(handle,x,y,w,h)
      end
   
   icon_position :  TUPEL_4[INTEGER,INTEGER,INTEGER,INTEGER] is
      obsolete "Not yet implemented"
      do
      end
   
   set_normal_position (x,y,w,h: INTEGER) is
      do
	 efox_mdi_child__set_normal_position(handle,x,y,w,h)
      end
   
   normal_position :  TUPEL_4[INTEGER,INTEGER,INTEGER,INTEGER] is
      obsolete "Not yet implemented"
      do
      end
   
     
feature {NONE}
   
   
   make (p: AGUI_MDI_CLIENT;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 init_composite
	 handle := efox_mdi_child__make(Current,p.handle,n.to_external)
	 p.register(Current)
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_mdi_child__make (this:like Current; hnd,n: POINTER) : POINTER is
      external "C"
      end	    
   
   efox_mdi_child__maximize(hnd: POINTER) is
      external "C"
      end
   
   efox_mdi_child__minimize(hnd: POINTER) is
      external "C"
      end	    
   
   efox_mdi_child__is_maximize(hnd: POINTER) : BOOLEAN is
      external "C"
      end	    
   
   efox_mdi_child__is_minimized(hnd: POINTER) : BOOLEAN is
      external "C"
      end	    
   
   efox_mdi_child__restore(hnd: POINTER) is
      external "C"
      end	    
   
   efox_mdi_child__set_icon_position(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end	    
   
   efox_mdi_child__set_normal_position(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end	    

   efox_mdi_child__next (hnd: POINTER) : AGUI_MDI_CHILD is
      external "C"
      end	    

   efox_mdi_child__set_title(hnd,str: POINTER) is
      external "C"
      end	    

   efox_mdi_child__title(hnd: POINTER) : POINTER is
      external "C"
      end	    

   efox_mdi_child__set_color(hnd: POINTER; n,col: INTEGER) is
      external "C"
      end	    

   efox_mdi_child__color(hnd: POINTER; n: INTEGER) : INTEGER is
      external "C"
      end	    

   efox_mdi_child__set_icon (hnd,ic: POINTER) is
      external "C"
      end	    

   efox_mdi_child__icon (hnd: POINTER) : AGUI_ICON is
      external "C"
      end	    

   efox_mdi_child__set_font (hnd,fnt: POINTER) is
      external "C"
      end	    

   efox_mdi_child__font (hnd: POINTER) : AGUI_FONT is
      external "C"
      end	    

   efox_mdi_child__resize(hnd: POINTER; w,h: INTEGER) is
      external "C"
      end	    

   efox_mdi_child__move(hnd: POINTER; x,y: INTEGER) is
      external "C"
      end	    

   efox_mdi_child__position(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end	    
   
end
