class  AGUI_MDI_CLIENT
   
   
inherit
   AGUI_SCROLLING_MIXIN
      end
   AGUI_COMPOSITE
      end
   
   
creation
   {ANY} make
   
   
feature {ANY}
   
   
   first_child :AGUI_MDI_CHILD is
      require
	 not is_zombie
      do
	 result := efox_mdi_client__first_child(handle)
      end
   
   active_child : AGUI_MDI_CHILD is
      require
	 not is_zombie
      do
	 result := efox_mdi_client__active_child(handle)
      end
   
   set_active_child (child: AGUI_MDI_CHILD) is
      require
	 not is_zombie
	 child /= Void
      do
	 efox_mdi_client__set_active_child(handle, child.handle)
      end
   
   cascade_offset : TUPEL_2[INTEGER,INTEGER] is
      require
	 not is_zombie
      do
	 efox_mdi_client__cascade_offset(handle,$temp_x, $temp_y)
	 create result.set_tupel(temp_x,temp_y)
      end
   
   set_cascade_offset (x,y: INTEGER) is
      require
	 not is_zombie
      do
	 efox_mdi_client__set_cascade_offset(handle,x,y)      
      end
   
   
feature {NONE}
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 init_composite
	 handle := efox_mdi_client__make(p.handle,n.to_external)
	 p.register(Current)
	 scroll_area_widget := Current
      end
   

feature {NONE}  -- private C binding
   
   
   temp_x, temp_y : INTEGER
   
   efox_mdi_client__make (this:like Current; hnd,n: POINTER) : POINTER is
      external "C"
      end	
   
   efox_mdi_client__set_cascade_offset (hnd: POINTER; x,y: INTEGER) is
      external "C"
      end
   
   efox_mdi_client__cascade_offset (hnd,x,y: POINTER) is     
      external "C"
      end
   
   efox_mdi_client__active_child (hnd: POINTER) : AGUI_MDI_CHILD is
      external "C"
      end

   efox_mdi_client__set_active_child (hnd,child: POINTER) is
      external "C"
      end

   efox_mdi_client__first_child (hnd: POINTER) : AGUI_MDI_CHILD is
      external "C"
      end

end
   
