class  AGUI_MENU_BUTTON


inherit
   AGUI_LABEL_BASE
      rename
	 contains as contains_point
      end
   AGUI_MENU
      rename
	 contains as contains_item
      end

    
creation
   {ANY} make
   
   
feature {NONE} -- constructor, not for reinitialization
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      do
	 create menu_items.with_capacity(8,1)
	 handle := efox_menu_button__make(Current,p.handle,$menu_handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
feature {ANY}
   
   
   toolbar_style : BOOLEAN is
      require
	 not is_zombie
      do
	 result := efox_menu_button__toolbar_style(handle)
      end
   
   
   set_toolbar_style (flag: BOOLEAN) is
      require
	 not is_zombie
      do
	 efox_menu_button__set_toolbar_style(handle, flag)
      end
   
   
   hide_arrow : BOOLEAN is
      require
	 not is_zombie
      do
	 result := efox_menu_button__hide_arrow(handle)
      end
   
   
   set_hide_arrow (flag: BOOLEAN) is
      require
	 not is_zombie
      do
	 efox_menu_button__set_hide_arrow(handle, flag)
      end   
   
   
   Side_bottom : INTEGER is 0
   Side_top : INTEGER is 1
   Side_left : INTEGER is 2
   Side_right : INTEGER is 3
      
   popup_side : INTEGER
            
   set_popup_side (n: INTEGER) is
      require
	 not is_zombie
	 n.in_range(Side_bottom, Side_right)
      do
	 popup_side := n
	 efox_menu_button__set_popup_side(handle, n)
      ensure
	 popup_side = n
      end
   
   
   
   Attach_left : INTEGER is 0
	 -- Popup attaches to the left side of the menu button

   Attach_top : INTEGER is 1
	 -- Popup attaches to the top of the menu button

   Attach_right : INTEGER is 2
	 -- Popup attaches to the right side of the menu button

   Attach_bottom : INTEGER is 3
	 -- Popup attaches to the bottom of the menu button

   Attach_center : INTEGER is 4
	 -- Popup attaches to the center of the menu button
   
   Attach_both : INTEGER is 5
	 -- Popup attaches to both sides of the menu button
   

   popup_attachment : INTEGER
   
   set_popup_attachment (n: INTEGER) is
      require
	 not is_zombie
	 n.in_range(Attach_left, Attach_both)
      do
	 popup_attachment := n
	 efox_menu_button__set_popup_attachment(handle,n)
      ensure
	 popup_attachment = n
      end
      
   
feature {NONE} -- private C binding
   
   
   efox_menu_button__make(this:like Current; hnd,mhnd,n,k: POINTER) : POINTER is
      external "C"
      end   
   
   efox_menu_button__set_toolbar_style(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox_menu_button__toolbar_style(hnd: POINTER): BOOLEAN is
      external "C"
      end
   
   efox_menu_button__set_hide_arrow(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox_menu_button__hide_arrow(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_menu_button__set_popup_side(hnd: POINTER; n: INTEGER) is
      external "C"
      end

   efox_menu_button__set_popup_attachment(hnd: POINTER; n: INTEGER) is
      external "C"
      end

end   
