class AGUI_MENU_CASCADE_ITEM
   
   
inherit 
   AGUI_MENU
      redefine is_zombie
      end
   AGUI_MENU_TEXT_ITEM
      end
   
   
creation
   {ANY} make, make_with_icon
   
   
feature {ANY} -- public interface
   
      is_zombie : BOOLEAN is
	 -- Test if menu is already destroyed.
      do
	 result := handle = default_pointer
      end
   

feature {NONE} -- constructor, not for reinitialization
   
   
   make (parent: AGUI_MENU_BASE; str: STRING) is
      require
	 parent /= Void
	 not parent.is_zombie
	 str /= Void
      local
	 mbar : AGUI_MENUBAR
	 dummy : POINTER
      do
	 menu := parent
	 mbar ?= parent
	 if mbar = Void then
	    handle := efox_menu_cascade_item__make_cascade(Current,parent.menu_handle, str.to_external, $menu_handle, dummy)
	 else
	    handle := efox_menu_cascade_item__make_menubar(Current,mbar.handle, str.to_external, $menu_handle, dummy)
	 end
	 create menu_items.with_capacity(8,1)
	 parent.menu_items.add_last(Current)
      ensure
	 not is_zombie
	 parent.count = old parent.count + 1
	 count = 0
	 icon = Void
      end
   
   
   make_with_icon (parent: AGUI_MENU_BASE; str: STRING; ic: AGUI_ICON) is
      require
	 parent /= Void
	 not parent.is_zombie
	 str /= Void	 
	 ic /= Void
	 not ic.is_zombie
      local
	 mbar : AGUI_MENUBAR
      do
	 menu := parent
	 mbar ?= parent
	 if mbar = Void then
	    handle := efox_menu_cascade_item__make_cascade(Current,parent.menu_handle, str.to_external, $menu_handle, ic.handle)
	 else
	    handle := efox_menu_cascade_item__make_menubar(Current,mbar.handle, str.to_external, $menu_handle, ic.handle)
	 end
	 create menu_items.with_capacity(8,1)
	 parent.menu_items.add_last(Current)
      ensure
	 not is_zombie
	 parent.count = old parent.count + 1
	 count = 0
	 ic = icon
      end   

      
feature {NONE} -- private C binding
   
   
   efox_menu_cascade_item__make_cascade(this:like Current; phnd, str, mhnd, ihnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_menu_cascade_item__make_menubar(this:like Current; phnd, str, mhnd, ihnd: POINTER) : POINTER is
      external "C"
      end   
   
end
