class AGUI_MENU_CHECK_ITEM
   

inherit
   AGUI_MENU_TEXT_ITEM
      redefine efox__callback_invoke
      end
   
   
creation 
   {ANY} make
   
   
feature {ANY}
   
   
   checked : BOOLEAN is
      require
	 not is_zombie
      do
	 result := efox_menu_check_item__checked(handle)
      end
   
   
   set_checked (new_value: BOOLEAN) is
      require
	 not is_zombie
      do
	 efox_menu_check_item__set_checked(handle, new_value)
      ensure
	 new_value = checked
      end
   
         
feature {NONE} -- constructor, not for reinitialization
   
   
   make (parent: AGUI_MENU; str: STRING; a: PROCEDURE[ANY,TUPLE[BOOLEAN]]) is
      require
	 parent /= Void
	 not parent.is_zombie
	 str /= Void
      do
	 menu := parent
	 handle := efox_menu_check_item__make (Current,parent.menu_handle, str.to_external)
	 parent.menu_items.add_last(Current)
	 callback := a
      ensure
	 not is_zombie
      end
      
   
feature {NONE}  -- private implementation
   
   
   efox_menu_check_item__make (this:like Current; phnd,str: POINTER) : POINTER is
      external "C"
      end
      
   efox_menu_check_item__checked (hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_menu_check_item__set_checked (hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end
   
   efox__callback_invoke is
      do
	 if callback /= Void then
	    callback.call([checked])
	 end
      end
      
   callback: PROCEDURE[ANY,TUPLE[BOOLEAN]]   
   
end
      
