class AGUI_MENU_COMMAND_ITEM
   
   
-- In the constructor call the parameter 'str' has a special syntax
-- to support easy setting  of the text, help_text, accelerator keys 
-- and tooltip_text.
-- Use a string like  "text %t accelerator %t help_text %t tooltip_text"
   
   
inherit
   AGUI_MENU_TEXT_ITEM
      redefine efox__callback_invoke
      end
   
   
creation 
   {ANY} make, make_with_icon
   
   
feature {NONE} -- constructor, not for reinitialization
   
   
   make (parent: AGUI_MENU; str: STRING; a: PROCEDURE[ANY,TUPLE]) is
	 -- See class description for special 'str' syntax.
      require
	 parent /= Void and then not parent.is_zombie
	 str /= Void
      do
	 menu := parent
	 handle := efox_menu_command_item__make (Current,parent.menu_handle, str.to_external, default_pointer)
	 parent.menu_items.add_last(Current)
	 callback := a
      end
      
   
   make_with_icon (parent: AGUI_MENU; str: STRING; ic: AGUI_ICON; a: PROCEDURE[ANY,TUPLE]) is
	 -- See class description for special 'str' syntax.
      require
	 parent /= Void and then not parent.is_zombie
	 str /= Void
	 ic /= Void and then not ic.is_zombie
      do
	 menu := parent
	 handle := efox_menu_command_item__make(Current,parent.menu_handle, str.to_external, ic.handle)
	 parent.menu_items.add_last(Current)
	 callback := a
      end
   
   
feature {NONE}  -- private implementation
   
   
   efox_menu_command_item__make (this:like Current; phnd, str, ic: POINTER) : POINTER is
      external "C"
      end
   
   efox__callback_invoke is
      do
	 if callback /= Void then
	    callback.call([])
	 end
      end
   
   callback: PROCEDURE[ANY,TUPLE]

end
