class AGUI_MENU_RADIO_ITEM
   
   
inherit
   AGUI_MENU_TEXT_ITEM
      redefine efox__callback_invoke
      end
   
   
creation
   {ANY} make
   
   
feature {ANY}
   
   
   group_id : INTEGER
   
   group_item_id : INTEGER
   
   
   set_group_item_id (new_value: INTEGER) is
      require
	 not is_zombie
      do
	 group_item_id := new_value
      end
   
   
   checked : BOOLEAN is
      require
	 not is_zombie
      do
	 result := efox_menu_radio_item__checked(handle)
      end
      
   
   set_checked (fl: BOOLEAN) is
      require
	 not is_zombie
      do
	 efox_menu_radio_item__set_checked(handle,fl)
      ensure
	 checked = fl
      end
   
   
   find_checked : INTEGER is
	 -- Returns the subid of the checked item in the group
	 -- where this button belongs to. If no item is checked, 
	 -- return -1
      require
	 not is_zombie
      local
	 item : AGUI_MENU_RADIO_ITEM
      do
	 item := efox_menu_radio_item__find_checked(handle)
	 if item = Void then
	    result := - 1
	 else
	    result := item.group_item_id
	 end
      end
   
   
feature {NONE} -- constructor, not for reinitialization
   
   
   make (parent: AGUI_MENU; str: STRING; gid,sid: INTEGER; a: PROCEDURE[ANY,TUPLE[INTEGER]]) is
      require
	 parent /= Void
	 not parent.is_zombie
	 str /= Void
      do
	 menu := parent
	 handle := efox_menu_radio_item__make (Current,parent.menu_handle, gid, str.to_external)
	 parent.menu_items.add_last(Current)
	 callback := a
	 group_id := gid
	 group_item_id := sid
      ensure
	 not is_zombie
	 group_id = gid
	 group_item_id = sid
      end
      
   
feature {NONE}  -- private implementation

   
   efox_menu_radio_item__make (this:like Current; phnd: POINTER;  gid: INTEGER; str: POINTER) : POINTER is
      external "C"
      end
   
   efox_menu_radio_item__find_checked(hnd: POINTER) : AGUI_MENU_RADIO_ITEM is
      external "C"
      end
   
   efox_menu_radio_item__checked(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_menu_radio_item__set_checked(hnd: POINTER; fl: BOOLEAN) is
      external "C"
      end   
   
   efox__callback_invoke is
      do
	 if callback /= Void then
	    callback.call([group_item_id])
	 end
      end
   
   callback: PROCEDURE[ANY,TUPLE[INTEGER]]

end
   
   
