class AGUI_MENUBAR


inherit
   AGUI_MENU_BASE
      rename contains as contains_menu_item
      end
   AGUI_WINDOW
      rename contains as contains_point
      end
   AGUI_FRAME_MIXIN
      redefine mixin_window
      end
   AGUI_PACKER_MIXIN
      redefine mixin_window
      end
   
   
   
creation
   make
   
   
feature {ANY}  -- public properties
      
   
   help_menu : AGUI_MENU_CASCADE_ITEM is
      require
	 not is_zombie
      do
	 result := efox_menubar__help_menu(handle)
      end
      
   
   set_help_menu (new_help: AGUI_MENU_CASCADE_ITEM) is
      require
	 not is_zombie
	 new_help /= Void implies not new_help.is_zombie 
	 new_help /= Void implies contains_menu_item(new_help)
      local
	 old_help_handle, new_help_handle : POINTER
      do
	 if new_help /= help_menu then
	    if help_menu /= Void then old_help_handle := help_menu.handle end
	    if new_help /= Void then new_help_handle := new_help.handle end
	    efox_menubar__set_help_menu(old_help_handle, new_help_handle)
	 end
      end

   
feature {ANY}  -- mixin configure
   
   
   mixin_window : AGUI_WINDOW is
	 -- redefine the mixin window references to this window
      do
	 result := Current
      end
   
      
feature {NONE} -- constructor, not for reinitialization
   
   
   make (p: AGUI_COMPOSITE; n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 create menu_items.with_capacity(8,1)
	 handle := efox_menubar__make(Current,p.handle, n.to_external, $temp_px)
	 menu_handle := handle
	 efox__window_hash_table.put(Current, temp_px)
	 set_layout_hints(Layout_side_top + Layout_fill_x);
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_menubar__make (this:like Current; phnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end
   
   efox_menubar__help_menu(hnd: POINTER) : AGUI_MENU_CASCADE_ITEM is
      external "C"
      end
   
   efox_menubar__set_help_menu(oldm,newm: POINTER) is
      external "C"
      end
   
end
   
