expanded class  AGUI_MESSAGE_BOX


creation 
   {ANY} make


feature {NONE} -- constructor
   
   make is
      do
      end
   
   
feature {ANY}  --  display message box 
   
   
   Buttons_ok : INTEGER is 0
   Buttons_ok_cancel : INTEGER is 1
   Buttons_yes_no : INTEGER is 2
   Buttons_yes_no_cancel : INTEGER is 3
   Buttons_quit_cancel : INTEGER is 4
   Buttons_quit_save_cancel : INTEGER is 5
   
   
   result_undefined : INTEGER is 0
	 -- this happens when a lower modal loop is exited or the 
	 -- window is destroyed
   
   Result_yes : INTEGER is 1
   Result_no : INTEGER is 2
   Result_ok : INTEGER is 3
   Result_cancel : INTEGER is 4
   Result_quit : INTEGER is 5
   Result_save : INTEGER is 6
   
   
   error (tw: AGUI_WINDOW; buttons: INTEGER; caption_str, message_str: STRING) is
      require
	 tw /= Void implies not tw.is_zombie
	 buttons.in_range(Buttons_ok, Buttons_quit_save_cancel)
	 caption_str /= Void
	 message_str /= Void
      do
	 last_result := efox_message_box__error_message(handle(tw), buttons, caption_str.to_external, message_str.to_external)
      ensure
	 last_result.in_range(Result_yes, Result_save)
      end
   
   
   warning (tw: AGUI_WINDOW; buttons: INTEGER; caption_str, message_str: STRING) is
      require
	 tw /= Void implies not tw.is_zombie
	 buttons.in_range(Buttons_ok, Buttons_quit_save_cancel)
	 caption_str /= Void
	 message_str /= Void
      do
	 last_result := efox_message_box__warning_message(handle(tw), buttons, caption_str.to_external, message_str.to_external)
      ensure
	 last_result.in_range(Result_yes, Result_save)
      end
   
   
   information (tw: AGUI_WINDOW; buttons: INTEGER; caption_str, message_str: STRING) is
      require
	 tw /= Void implies not tw.is_zombie
	 buttons.in_range(Buttons_ok, Buttons_quit_save_cancel)
	 caption_str /= Void
	 message_str /= Void
      do
	 last_result := efox_message_box__information_message(handle(tw), buttons, caption_str.to_external, message_str.to_external)
      ensure
	 last_result.in_range(Result_yes, Result_save)
      end
   
   
   question (tw: AGUI_WINDOW; buttons: INTEGER; caption_str, message_str: STRING) is
      require
	 tw /= Void implies not tw.is_zombie
	 buttons.in_range(Buttons_ok, Buttons_quit_save_cancel)
	 caption_str /= Void
	 message_str /= Void
      do
	 last_result := efox_message_box__question_message(handle(tw), buttons, caption_str.to_external, message_str.to_external)
      ensure
	 last_result.in_range(Result_yes, Result_save)
      end
   
   
   last_result : INTEGER
	 -- the return value from the last executed messagebox
   

feature {NONE} -- private C binding   
   
   handle(w: AGUI_WINDOW) : POINTER is
      do
	 if w /= Void then
	    result := w.handle
	 end
      end
   
   efox_message_box__warning_message(hnd: POINTER; b: INTEGER; c,m: POINTER) : INTEGER is
      external "C"
      end
   
   efox_message_box__question_message(hnd: POINTER; b: INTEGER; c,m: POINTER) : INTEGER is
      external "C"
      end
   
   efox_message_box__error_message(hnd: POINTER; b: INTEGER; c,m: POINTER) : INTEGER is
      external "C"
      end
   
   efox_message_box__information_message(hnd: POINTER; b: INTEGER; c,m: POINTER) : INTEGER is
      external "C"
      end
   

end
   
   
