deferred class  AGUI_PACKER_MIXIN
   
   
inherit
   AGUI_MIXIN
      end


feature {ANY}  -- packing options
   
   
   Pack_uniform_width  : INTEGER is 0
   Pack_uniform_height : INTEGER is 1
   Pack_uniform_width_and_height  : INTEGER is 2
   
   
   set_packing_hints (n: INTEGER) is
      require
	 not mixin_window.is_zombie
	 n.in_range(Pack_uniform_width, Pack_uniform_width_and_height)
      do
	 efox_imp_window__set_packing_hints(mixin_window.handle,n)
      end
   
   
   set_spacing(vertical,horizontal: INTEGER) is
      require
	 not mixin_window.is_zombie
	 vertical >= 0  and horizontal >= 0
      do
	 efox_imp_window__set_spacing(mixin_window.handle, vertical,horizontal)
      end
   
   
   set_padding (top,bottom,left,right : INTEGER) is
      require
	 not mixin_window.is_zombie
	 top >= 0 and bottom >= 0 and left >= 0 and right >= 0
      do
	 efox_imp_window__set_padding(mixin_window.handle, top,bottom,left,right)
      end
   
   
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- window in that this class is mixed in
      deferred
      end
   
   
feature  {NONE} -- private C binding 
   
   
   efox_imp_window__set_spacing(hnd: POINTER; vertical,horizontal: INTEGER) is
      external "C"
      end
   
   efox_imp_window__set_packing_hints(hnd: POINTER; n:INTEGER) is
      external "C"
      end
   
   efox_imp_window__set_padding(hnd: POINTER; top,bottom,left,right: INTEGER) is
      external "C"
      end
   
end
