class  AGUI_PAINT_CONTEXT
   
creation
   {ANY} make
   
   
      --TODO Xor drawing
   
   
feature {ANY}  -- color management
   
   set_color (color: AGUI_COLOR) is
      do
	 efox_paint_context__set_color(pc_handle, color.to_integer)
      end
   
   clear (color: AGUI_COLOR) is
      obsolete "Not yet implemented"
      do
	 efox_paint_context__clear(pc_handle, color.to_integer)
      end
   
feature {ANY}  -- line style features
   
   Line_join_miter : INTEGER is 0
   Line_join_round : INTEGER is 1
   Line_join_bevel : INTEGER is 2
   
   Line_cap_butting : INTEGER is 0
   Line_cap_round : INTEGER is 1
   Line_cap_projecting : INTEGER is 2
   
   Line_solid : INTEGER is 0
   Line_dotted : INTEGER is 1
   Line_dashed : INTEGER is 2
   Line_dashed_dotted : INTEGER is 3
   
   
   line_width : INTEGER
   line_style : INTEGER
   line_cap_style : INTEGER
   line_join_style : INTEGER
   
   
   set_line_style (width, pattern, cap_style, join_style: INTEGER) is
      obsolete "Not yet implemented"
      require
	 is_painting_initialized
      do
      end
   
   
   set_line_width (width: INTEGER) is
      require
	 is_painting_initialized
	 width >= 0
      do
	 efox_paint_context__set_line_width(pc_handle,width)
      end
   
   
   Fill_style_solid : INTEGER is 0
   
   fill_style : INTEGER
   
   set_fill_style (style: INTEGER) is
      obsolete "Not yet implemented"
      do
      end
   
   
feature {ANY}  -- simple figure drawing
   
   
   draw_point (x,y: INTEGER) is
      do
	 efox_paint_context__point(pc_handle,x,y)
      end
   
   
   draw_line (x1,y1,x2,y2: INTEGER) is
      do
	 efox_paint_context__line(pc_handle,x1,y1,x2,y2)
      end
   
   
   draw_rectangle (x, y, w, h: INTEGER) is
      do
	 efox_paint_context__rectangle(pc_handle,x,y,w,h)
      end
   
   draw_filled_rectangle (x, y, w, h: INTEGER) is
      do
	 efox_paint_context__filled_rectangle(pc_handle,x,y,w,h)
      end
   
   draw_rectangle_3d (x, y, w, h, border_width, border_type: INTEGER; col1,col2: AGUI_COLOR) is
      do
	 efox_paint_context__rectangle_3d(pc_handle,x,y,w,h,border_width,border_type,col1.to_integer,col2.to_integer)
      end
   
   
   draw_rounded_rectangle (x,y,w,h, rx,ry: INTEGER) is      
      do
	 efox_paint_context__rrectangle(pc_handle,x,y,w,h,rx,ry)
      end
   
   draw_filled_rounded_rectangle (x,y,w,h, rx,ry: INTEGER) is
      do
	 efox_paint_context__fill_rrectangle(pc_handle,x,y,w,h,rx,ry)
      end
   
   
   draw_polygon (coords: ARRAY[INTEGER]) is
      require
	 coords /= Void
	 coords.count.even
      do
	 efox_paint_context__draw_polygon(pc_handle,coords.to_external, coords.count)
      end
   
   draw_filled_polygon (coords: ARRAY[INTEGER]; even_odd_fill: BOOLEAN) is
      require
	 coords /= Void
	 coords.count.even
      do
	 efox_paint_context__draw_fill_polygon(pc_handle,coords.to_external, coords.count, even_odd_fill)
      end
   	 
   draw_triangle (x1,y1,x2,y2,x3,y3: INTEGER) is      
      obsolete "Not yet implemented"
      do
	 efox_paint_context__triangle(pc_handle, x1,y1,x2,y2,x3,y3)
      end
   
   draw_filled_triangle (x1,y1,x2,y2,x3,y3: INTEGER) is
      obsolete "Not yet implemented"
      do
	 efox_paint_context__fill_triangle(pc_handle, x1,y1,x2,y2,x3,y3)
      end
   
   
   draw_arc (x,y,w,h, a1,a2: INTEGER) is
      do
	 efox_paint_context__arc(pc_handle, x,y,w,h,a1,a2)
      end
   
   draw_filled_arc (x,y,w,h, a1,a2: INTEGER) is
      do
	 efox_paint_context__fill_arc(pc_handle, x,y,w,h,a1,a2)
      end
   
   
feature {ANY}  -- clipping
   
   
   set_clipping_rectangle (x,y,w,h: INTEGER) is
      require
	 is_painting_initialized
      do
	 efox_paint_context__set_clipping_rect(pc_handle,x,y,w,h)	 
      end
   
   clear_clipping_rectangle is
      require
	 is_painting_initialized
      do
	 efox_paint_context__clear_clipping_rect(pc_handle)
      end
   
   
feature {ANY}  -- icon and image drawing
   
   
   draw_icon (x,y: INTEGER icon: AGUI_ICON) is
	 -- draw the icon at the current position
      require
	 is_painting_initialized
	 icon /= Void
	 not icon.is_zombie
      do
	 efox_paint_context__draw_icon(pc_handle, icon.handle, x, y)
      end
   

feature {ANY}  -- text drawing
   
   font : AGUI_FONT is
      require
	 is_painting_initialized
      do
	 result := efox_paint_context__get_font(pc_handle)
      ensure
	 result /= Void
      end
   
   
   set_font (fnt : AGUI_FONT) is
      require
	 is_painting_initialized
	 fnt /= Void
	 not fnt.is_zombie
      do 
	 efox_paint_context__set_font(pc_handle, fnt.handle)
      end
   
   
   draw_string (x,y: INTEGER; str: STRING) is
      require
	 is_painting_initialized
	 str /= Void
      do
	 efox_paint_context__draw_string(pc_handle, x,y,str.to_external, str.count)
      end
   
   
   draw_substring (x,y: INTEGER; str: STRING; aidx, eidx: INTEGER) is
      require
	 is_painting_initialized
	 str /= Void
	 aidx <= eidx+1
      do
	 efox_paint_context__draw_substring(pc_handle, x,y, str.to_external, aidx, eidx)
      end
   
   
feature {ANY}
   
   
   is_painting_initialized : BOOLEAN is
      do
	 result := pc_handle.is_not_null
      end
   
   
feature {NONE}  -- constructor, not for reinitialization   
   
   
   make is
      do
	 -- currently we have nothing to do
      end
   
   
feature {AGUI_BASE_CLIENT_CONTROL} -- very private implementation section
   
   
   pc_handle : POINTER
   
   efox_begin_paint(winhandle: POINTER) is
      do
	 pc_handle := efox_paint_context__begin_paint(winhandle)
      end
   
   efox_end_paint(winhandle: POINTER) is
      do
	 pc_handle := efox_paint_context__end_paint(pc_handle,winhandle)
      end
   
   
   efox_begin_buffered_paint(winhandle: POINTER) is
      do
	 pc_handle := efox_paint_context__begin_buffered_paint(winhandle)
      end
   
   efox_end_buffered_paint(winhandle: POINTER) is
      do
	 pc_handle := efox_paint_context__end_buffered_paint(pc_handle,winhandle)
      end
   
   
feature {NONE} -- private C Binding
   
   
   efox_paint_context__make : POINTER is
      external "C"
      end
      
   efox_paint_context__set_line_width(hnd: POINTER; n: INTEGER) is
      external "C"
      end
      
   efox_paint_context__set_color(hnd: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_paint_context__clear(hnd: POINTER; col: INTEGER) is
      external "C"
      end
	 
   efox_paint_context__set_clipping_rect(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
   efox_paint_context__clear_clipping_rect(hnd: POINTER) is
      external "C"
      end
	 
   efox_paint_context__draw_icon(hnd,ic: POINTER; x,y: INTEGER) is
      external "C"
      end
	 
   efox_paint_context__begin_paint (hnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_paint_context__end_paint (hnd,whnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_paint_context__begin_buffered_paint (hnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_paint_context__end_buffered_paint (hnd,whnd: POINTER) : POINTER is
      external "C"
      end
   
   efox_paint_context__set_font (pc, fnt: POINTER) is
      external "C"
      end
   
   efox_paint_context__get_font (pc: POINTER) : AGUI_FONT is
      external "C"
      end
   
   efox_paint_context__draw_string (pc: POINTER; x,y:INTEGER; str: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_paint_context__draw_substring (pc: POINTER; x,y: INTEGER; str: POINTER; aidx,eidx: INTEGER) is
      external "C"
      end
   
   efox_paint_context__point(pc: POINTER; x,y: INTEGER) is
      external "C"
      end
   
   efox_paint_context__line(pc: POINTER; x1,y1,x2,y2: INTEGER) is
      external "C"
      end
   
   efox_paint_context__rectangle(pc: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
   efox_paint_context__filled_rectangle(pc: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
   efox_paint_context__rectangle_3d(pc: POINTER; x,y,w,h,fw,ft,col1,col2: INTEGER) is
      external "C"
      end
   
   efox_paint_context__rrectangle(pc: POINTER; x,y,w,h,rx,ry: INTEGER) is
      external "C"
      end
   
   efox_paint_context__fill_rrectangle(pc: POINTER; x,y,w,h,rx,ry: INTEGER) is
      external "C"
      end
   
   efox_paint_context__fill_triangle(pc: POINTER; x1,y1,x2,y2,x3,y3: INTEGER) is
      external "C"
      end
   
   efox_paint_context__triangle(pc: POINTER; x1,y1,x2,y2,x3,y3: INTEGER) is
      external "C"
      end
   
   efox_paint_context__arc(pc: POINTER; x,y,w,h,a1,a2: INTEGER) is
      external "C"
      end
   
   efox_paint_context__fill_arc(pc: POINTER; x,y,w,h,a1,a2: INTEGER) is
      external "C"
      end

   efox_paint_context__draw_polygon(pc,p: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_paint_context__draw_fill_polygon(pc,p: POINTER; n: INTEGER; fl: BOOLEAN) is
      external "C"
      end
   
end
   
   
   
