class AGUI_POPUP_MENU
   
--IMPROVE index in "show" and "show_and_destroy" is ignored at the moment
   
inherit
   AGUI_MENU
      redefine is_zombie
      end
   AGUI_GLOBALS
      end
   
   
creation
   {ANY} make
   
   
feature {ANY} -- public interface
   
   
   show (relative_to: AGUI_WINDOW;  x,y: INTEGER; index: INTEGER) is
	 -- This makes the popup menu visible, enters a modal loop 
	 -- and waits until the user has activated a menu item.
	 -- The menu is positioned so that the item under x,y is the 
	 -- 'index' menu item.
      require
	 not is_zombie
      do
	 efox_popup_menu__show(relative_to.handle, handle, x,y, index)
      ensure
	 not is_zombie
      end
   
   
   show_and_destroy (relative_to: AGUI_WINDOW;  x,y: INTEGER; index: INTEGER) is
	 -- This makes the popup menu visible, enters a modal loop 
	 -- and waits until the user has activated a menu item.
	 -- The popup is destroyed before returning from the menu. 
	 -- The menu is positioned so that the item under x,y is the 
	 -- 'index' menu item.
      require
	 not is_zombie
      do
	 show(relative_to, x,y, index)
	 destroy
      ensure
	 is_zombie
      end
   
   
   destroy is
	 -- Never destroy while menu is poped up.
      require
	 not is_zombie
      do
	 efox_popup_menu__destroy(handle)
	 application.unregister_popup_menu(Current)
	 handle := default_pointer
      ensure
	 is_zombie
      end
   
   
   is_zombie : BOOLEAN is
	 -- Test if menu is already destroyed.
      do
	 result := handle = default_pointer
      end
   
feature {AGUI_WINDOW}
   
   handle: POINTER   
   

feature {NONE} -- constructor
      
   
   make is
	 -- Create a new popup menu.
      do
	 create menu_items.with_capacity(8,1)
	 handle := efox_popup_menu__make(Current,$menu_handle)
	 application.register_popup_menu(Current)
      end
   
   
feature {NONE} -- private C binding   
   
   efox_popup_menu__make(this:like Current; mhnd: POINTER) : POINTER is
      external "C"
      end
      
   efox_popup_menu__show_destroy(win,hnd: POINTER; x,y,index: INTEGER) is
      external "C"
      end
   	 
   efox_popup_menu__show(win,hnd: POINTER; x,y,index: INTEGER) is
      external "C"
      end
   
   efox_popup_menu__destroy(hnd: POINTER) is
      external "C"
      end
   
end
