class  AGUI_POPUP_WINDOW
   
--FATAL Fatal Error:   Absturz wenn Popup mit maus angeclickt wird.
   
-- For the child windows a popup behaves normally like a 
-- vertical frame. But it also can be in horizontal mode 
-- where all widgets are aligned horizontal.

--   
--  From the packer mixin the only method which have an
--  effect is the 'set_packing_hints' method
--
   
   
inherit
   AGUI_SHELL_WINDOW
      redefine efox__callback_specific1
      end
   AGUI_FRAME_MIXIN
      redefine mixin_window
      end
   AGUI_PACKER_MIXIN
      redefine mixin_window      
      end
   

creation
   {ANY} make
     

feature {NONE} -- constructor
   
   
   make (owner: AGUI_WINDOW; name: STRING) is
	 -- Creates a popup window, that is owned by another
	 -- Window.
      require
	 owner /= Void and then not owner.is_zombie
      do
	 handle := efox_popup_window__make(Current,owner.handle, name.to_external,$temp_px)
	 efox__window_hash_table.put(Current, temp_px)
	 create accelerator_table.make(handle)
      end
   

feature {ANY}  -- composite options
   
   
   popup (x,y,w,h: INTEGER) is
	 -- Popup window at given coordinates.
	 -- The coordinates are a hint and will be modified
	 -- so that the window does not extend outside the
	 -- root window. In 'shrinkWrap' mode the
	 -- 'w' and 'h' parameter are ignored.
      require
	 not is_zombie
      do
	 efox_popup_window__popup(handle, x,y,w,h)
      end
   
   
   popdown is
	 -- Hide the popup window.
      do
	 efox_popup_window_popdown(handle)
      end
   
   
   horizontal_orientation : BOOLEAN is
	 -- Return popup orientation.
      require
	 not is_zombie
      do
	 result := efox_popup_window__horizontal_orientation(handle)
      end
  
   
   set_horizontal_orientation (flag: BOOLEAN) is      
	 --Change popup orientation.
      require
	 not is_zombie
      do
	 efox_popup_window__set_horizontal_orientation(handle,flag)
      end
   
   
   shrink_wrap : BOOLEAN is 
	 -- Return shrinkwrap mode.
      require
	 not is_zombie
      do
	 result := efox_popup_window__shrink_wrap(handle)
      end
   
   
   set_shrink_wrap (new_mode : BOOLEAN) is 
	 -- Change shrinkwrap mode. Shrink wrap means that the
	 -- width and height parameter on every 'popup' call are
	 -- ignored and that the popup is sized to the default
	 -- width and height.
      require
	 not is_zombie
      do
	 efox_popup_window__set_shrink_wrap(handle,new_mode)
      end
   
   
feature {ANY}
   
   
   on_popdown : ROUTINE[ANY,TUPLE] is
      do
	 result ?= find_callback_agent(On_window_specific1_event)
      end
   
   
   set_on_popdown (action: ROUTINE[ANY,TUPLE]) is
      do
	 set_callback_agent(On_window_specific1_event, action)
      end
   
   
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- window in that this class is mixed in
      do
	 result := Current
      end
   
   
feature {NONE} -- private C binding   
   
   
   efox__callback_specific1(what: INTEGER; state: BOOLEAN obj: ANY) is
      local
	 a: ROUTINE[ANY,TUPLE]
      do
	 a := find_callback_agent(On_window_specific1_event)
	 if a /= Void then
	    a.call([])
	 end
      end
   
   efox_popup_window__make(this:like Current; phnd, n,keyptr: POINTER) : POINTER is
      external "C"
      end
   
   efox_popup_window__popup(hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
   efox_popup_window_popdown(hnd: POINTER) is
      external "C"
      end
   
   efox_popup_window__horizontal_orientation(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_popup_window__set_shrink_wrap(hnd: POINTER; new_model: BOOLEAN) is
      external "C"
      end
   
   efox_popup_window__shrink_wrap(hnd: POINTER) is
      external "C"
      end
   
   efox_popup_window__set_horizontal_orientation(hnd: POINTER; flag: BOOLEAN) is
      external "C"
      end

end
   

