class AGUI_RADIO_BUTTON
   
   
inherit
   AGUI_LABEL_BASE
      redefine
	 efox__callback_command
      end
   
   
creation
   {ANY} make
   

feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE; n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_radio_button__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
feature {ANY}   -- event handler
   
   
   on_command: PROCEDURE[ANY,TUPLE] is
	 -- Agent that is called when the user clicks the button.
      require
	 not is_zombie
      do
	 result := find_callback_agent(On_command_event)
      end

   set_on_command (action: PROCEDURE[ANY,TUPLE]) is
	 -- Sets the agent for the click action.
      require
	 not is_zombie
      do
	 set_callback_agent(On_command_event,action)
      end
   

feature {ANY}
   
   
   group_id : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_radio_button__group_id(handle)
      end
         
   set_group_id (gid: INTEGER) is
      require
	 not is_zombie
      do
	 efox_radio_button__set_group_id(handle,gid)
      end
   
   
   checked : BOOLEAN is
	 -- Return 'true' if checked otherwise false
      require
	 not is_zombie
      do
	 result := efox_radio_button__checked(handle)
      end   
   
   set_checked (new_value: BOOLEAN) is
	 -- Set button in 'true' or 'false' mode.
      require
	 not is_zombie
      do
	efox_radio_button__set_checked(handle,new_value)
      end
   
   
feature {ANY} -- Appearance properties
   
   
   radio_color : AGUI_COLOR is
      require
	 not is_zombie
      do
	 result.from_integer(efox_radio_button__radio_color(handle))
      end
   
   set_radio_color (col: AGUI_COLOR) is
      require
	 not is_zombie
      do
	 efox_radio_button__set_radio_color(handle, col.to_integer)
      end
   
   
feature {NONE} -- private C binding
   
   efox__callback_command(idx: INTEGER; state: BOOLEAN; obj: ANY) is
      local
	 a : PROCEDURE[ANY,TUPLE]
      do
	 a := find_callback_agent(On_command_event)
	 if a /= Void then
	    a.call([])
	 end
      end
   
   efox_radio_button__make(this:like Current; hnd,n,key: POINTER) : POINTER is
      external "C"
      end   
   
   efox_radio_button__set_group_id (hnd: POINTER; gid: INTEGER) is
      external "C"
      end
   
   efox_radio_button__group_id (hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_radio_button__radio_color (hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_radio_button__set_radio_color (hnd: POINTER; col: INTEGER) is
      external "C"
      end
   
   efox_radio_button__set_checked(hnd: POINTER; v: BOOLEAN) is
      external "C"
      end
   
   efox_radio_button__checked(hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_radio_button__maybe_checked(h: POINTER) : BOOLEAN is
      external "C"
      end
      
   efox_radio_button__set_maybe_checked(h: POINTER) is
      external "C"
      end
   
end
   
   
