class  AGUI_REGISTRY_SETTINGS
   
inherit
   AGUI_SETTINGS
      redefine clear, save
      end
   MEMORY
      redefine dispose
      end
   
creation
   make
   
   
feature {NONE} -- constructor
   
   
   dispose is
      do
	 if is_modified then
	    save
	 end
	 efox_registry_settings__dispose(handle)
      end
   
   make is
      do
	 init_settings(efox_registry_settings__make)
      end
      
   singleton_memory: AGUI_REGISTRY_SETTINGS is
      once
	 Result := Current;
      end
   
   
feature {ANY}  -- public features
   
   
   save is
	 -- Make all changes persistent.
      do
	 last_status := efox_registry_settings__save(handle)
      end
   
   
   clear is
	 -- Remove all sections and entries.
      do
	 handle := efox_registry_settings__clear(handle)
      end
   
   
feature {NONE} -- private C binding   
   
   
   efox_registry_settings__dispose(hnd: POINTER) is
      external "C"
      end
   
   efox_registry_settings__make : POINTER is
      external "C"      
      end
   
   efox_registry_settings__save(hnd: POINTER) : BOOLEAN is
      external "C"
      end      
   
   efox_registry_settings__clear(hnd: POINTER) : POINTER is
      external "C"
      end
   
   
invariant

   is_real_singleton: Current = singleton_memory   
   
end
   
