deferred  class AGUI_SCROLLING_MIXIN
   
   
feature {ANY}
   
   
   Scrollbar_show_when_needed : INTEGER is 0
	 -- show the scrollbar only when content area is to large
   
   Scrollbar_show_never : INTEGER is 1
	 -- never show the scrollbar
   
   Scrollbar_show_always : INTEGER is 2
	 -- always show scrollbar
   
   Scrollbar_prefer_resize : INTEGER is 3
	 -- do not show a scrollbar but resize window to fit its content
      
   
   
   scroll_tracking : BOOLEAN is
      require
	 not mixin_window.is_zombie
      do
	 result := efox_scrolling_mixin__tracking(mixin_window.handle)
      end
   
   
   set_scroll_tracking (flag: BOOLEAN) is
      require
	 not mixin_window.is_zombie
      do
	 efox_scrolling_mixin__set_tracking(mixin_window.handle, flag)
      end
	    
   
   scroll_vertical_mode : INTEGER is
	 -- what should we do with the vertical scrollbar     
      require
	 not mixin_window.is_zombie
      do
	 result := efox_scrolling_mixin__vmode(mixin_window.handle)
      ensure
	 result.in_range(Scrollbar_show_when_needed, Scrollbar_prefer_resize)
      end
   
   
   set_scroll_vertical_mode (n: INTEGER) is
      require
	 not mixin_window.is_zombie
	 n.in_range(Scrollbar_show_when_needed, Scrollbar_prefer_resize)
      do
	 efox_scrolling_mixin__set_vmode(mixin_window.handle,n)
      end
   
   
   scroll_horizontal_mode : INTEGER is
	 -- what should we do with the horizontal scrollbar
      require
	 not mixin_window.is_zombie
      do
	 result := efox_scrolling_mixin__hmode(mixin_window.handle)
      ensure
	 result.in_range(Scrollbar_show_when_needed, Scrollbar_prefer_resize)
      end
   
   
   set_scroll_horizontal_mode (n: INTEGER) is
      require
	 not mixin_window.is_zombie
	 n.in_range(Scrollbar_show_when_needed, Scrollbar_prefer_resize)
      do
	 efox_scrolling_mixin__set_hmode(mixin_window.handle, n)
      end
   
   
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- Window in that this class is mixed in.
      deferred
      end
   
   
feature {NONE}
   
   
   efox_scrolling_mixin__tracking (hnd: POINTER) : BOOLEAN is
      external "C"
      end
   
   efox_scrolling_mixin__set_tracking(hnd: POINTER; flag: BOOLEAN) is
      external "C"
      end   
   
   efox_scrolling_mixin__set_vmode (hnd: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_scrolling_mixin__vmode (hnd: POINTER): INTEGER is
      external "C"
      end
   
   efox_scrolling_mixin__set_hmode (hnd: POINTER; n: INTEGER) is
      external "C"
      end
   
   efox_scrolling_mixin__hmode (hnd: POINTER): INTEGER is
      external "C"
      end
   
end
   
