--  A shell window is a toplevel window that is directly
--  a child of the root window (desktop).


deferred class  AGUI_SHELL_WINDOW
   
   
inherit
   AGUI_COMPOSITE
      end
   
   
feature {ANY} -- position of window
   
   
   move (x,y: INTEGER) is
	 -- moves the window to another position
      require
	 not is_zombie
      do
	 efox_shell_window__move(handle,x,y)
      end

   
   resize (w,h: INTEGER) is
	 -- changes the size of the window
      require
	 not is_zombie
      do
	 efox_shell_window__resize(handle,w,h)
      end
   
   
   position (x,y,w,h: INTEGER) is
      -- change size and position of the window
      require
	 not is_zombie
      do
	 efox_shell_window__position(handle,x,y,w,h)
      end
   
   
feature {ANY} -- shell wide accelerator
   
   
   accelerator_table : AGUI_KEY_ACCELERATOR_TABLE
   
   
feature {NONE} -- private C binding   
   
   
   efox__callback_accelerator(n: INTEGER) is
      do
	 accelerator_table.callback(n)
      end
      
   efox_shell_window__move (hnd: POINTER; x,y: INTEGER) is
      external "C"
      end

   efox_shell_window__resize (hnd: POINTER; w,h: INTEGER) is
      external "C"
      end

   efox_shell_window__position (hnd: POINTER; x,y,w,h: INTEGER) is
      external "C"
      end
   
end
   
