class AGUI_STATE_BUTTON
   
   
inherit
   AGUI_TOGGLE_BUTTON
      rename 
	 make as make_toggle,
	 set_icon as set_normal_icon,
	 icon as normal_icon
	 set_text as set_normal_text
	 text as normal_text
      end
   
   
creation
   {ANY} make
   
   
feature {ANY} -- rename important features
   
   
   set_pressed (flag: BOOLEAN) is
      do
	 set_alternate_state(flag)
      end
   
   
   pressed : BOOLEAN is
      do
	 result := alternate_state
      end
   
   
   icon : AGUI_ICON is
      require
	 not is_zombie
      do
	 result := normal_icon
      end
   
   
   set_icon (new_value: AGUI_ICON) is
      require
	 not is_zombie
	 new_value /= Void implies not new_value.is_zombie
      do
	 set_normal_icon(new_value) 
	 set_alternate_icon(new_value)
      end
   
   
   text : STRING is
      require
	 not is_zombie
      do
	 result := normal_text
      end
   
   
   set_text (new_value: STRING) is
      do
	 set_normal_text(new_value)
	 set_alternate_text(new_value)
      end
   
   
   
feature {NONE} -- constructor, not for reinitialization
   
   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_state_button__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_state_button__make(this:like Current; hnd,n,key: POINTER) : POINTER is
      external "C"
      end   
   
end
