expanded class AGUI_STRING_TOOLS


feature
   
   
   trim_begin (str: STRING) is
	 -- trim whitespaces from begin
      require
	 str /= Void
      local
	 i,n,count: INTEGER
      do
	 from
	    i := 1
	    n := str.upper
	 until
	    i > n
	 loop
	    if str.item(i).code <= 32 then
	       count := count + 1
	    else
	       i := n
	    end
	    i := i + 1
	 end
	 str.remove_first(count)
      end
   
   
   trim_end (str: STRING) is
	 -- trim whitespaces from end
      require
	 str /= Void
      local
	 i,n: INTEGER
      do
	 from
	    i := str.upper
	    n := 0
	 until
	    i = 0
	 loop
	    if str.item(i).code <= 32 then
	       n := n + 1
	       i := i - 1
	    else
	       i := 0
	    end
	 end
	 str.remove_tail(n)
      end
   
   
   trim (str: STRING) is
      do
	 trim_begin(str)
	 trim_end(str)
      end
   
   
   simplify_whitespace (str: STRING) is
      require
	 str /= Void
      local
	 i,n,j: INTEGER
	 flag: BOOLEAN
      do
	 -- simplify whitespaces
	 from
	    j := str.lower
	    i := str.lower
	    n := str.upper
	 until 
	    i > n
	 loop
	    if str.item(i).code <= 32 then
	       if flag then
		  -- skip this separator because we have found one before
		  i := i + 1
	       else
		  -- copy first separator character
		  str.put(str.item(i), j)
		  j := j + 1
		  i := i + 1
	       end
	       flag := true
	    else
	       -- copy non separator character
	       flag := false
	       str.put(str.item(i), j)
	       j := j + 1
	       i := i + 1
	    end
	 end
	 check j <= i end
	 str.remove_tail(i-j)
	 --IMPROVE optimize this
	 trim_begin(str)
	 trim_end(str)
      end
     
   
   split_newline_separated_string (s: STRING) : ARRAY[STRING] is
      do
	 result := split_string(s,'%N')
      ensure
	 result /= Void
	 result.lower = 1
      end
   
   
   join_string (a: ARRAY[STRING]; char: CHARACTER) : STRING is
      local
	 i: INTEGER
      do
	 result := ""
	 from i := a.lower; until i > a.upper loop
	    result.append_string(a.item(i))
	    if i /= a.upper then result.extend(char) end
	    i := i + 1
	 end
      end
   
   
   split_string(s: STRING; char: CHARACTER) : ARRAY[STRING] is
      local
	 s2: STRING
	 new_idx,idx: INTEGER
      do
	 create result.with_capacity(s.occurrences(char)+1,1)
	 from
	    idx := s.lower
	 until
	    idx = 0 or else idx > s.upper
	 loop
	    new_idx := s.index_of(char,idx)
	    if new_idx = 0 then
	       s2 := s.substring(idx, s.count)
	       idx := 0
	    else
	       s2 := s.substring(idx, new_idx-1)
	       idx := new_idx + 1
	    end
	    result.add_last(s2)
	 end
      ensure
	 result /= Void
	 result.lower = 1
      end
   

   append_substring_in (res,s: STRING; low,high: INTEGER) is
      local
	 i: INTEGER
      do
	 from i := low until i > high loop
	    res.extend(s.item(i))
	    i := i + 1
	 end
      end
   
end
