class  AGUI_SWITCHER
   

inherit
   AGUI_PACKER
      rename make as make_packer
      end
   
   
creation
   {ANY} make
   

feature {NONE} -- constructor

   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_switcher__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
  
feature {ANY}  -- public features
   
   
   no_of_pages : INTEGER is
	 -- Return the number of pages. This is the
	 -- same as the number of child windows.
      require
	 not is_zombie
      do
	 result := efox_switcher__no_of_pages(handle)
      ensure
	 result >= 0
      end
   
   
   current_page : INTEGER is
	 -- Get the index of the current displayed page.
      require
	 not is_zombie
      do
	 result := efox_switcher__current_page(handle)
      end
   
   
   set_current_page (n: INTEGER) is
	 -- Set the index of the current displayed page.
      require
	 not is_zombie
	 n.in_range(1,no_of_pages)
      do
	 efox_switcher__set_current_page(handle,n)
      end
   
   
   current_window : AGUI_WINDOW is
      require
	 not is_zombie
      do
	 result := efox_switcher__current_window(handle)
      end
   
   
feature {NONE} -- private C binding
   
   
   efox_switcher__make (this:like Current; hnd,n,keyptr: POINTER) : POINTER is
      external "C"
      end
	 
   efox_switcher__no_of_pages(hnd: POINTER) : INTEGER is
      external "C"
      end
	 
   efox_switcher__set_current_page(hnd: POINTER; n: INTEGER) is
      external "C"
      end
	 
   efox_switcher__current_page(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_switcher__current_window(hnd: POINTER) : AGUI_WINDOW is
      external "C"
      end
   
end
