class  AGUI_TABBOOK
   
   
inherit
   AGUI_COMPOSITE
      redefine efox__callback_command
      end
   AGUI_FRAME_MIXIN
      redefine mixin_window
      end
   AGUI_PACKER_MIXIN
      redefine mixin_window
      end

creation
   {ANY} make
   

feature {NONE} -- constructor

   
   make (p: AGUI_COMPOSITE;  n: STRING) is
      require
	 p /= Void and n /= Void
      do
	 handle := efox_tabbook__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
      end
   
   
feature {ANY} -- mixed inside
   
   
   mixin_window : AGUI_WINDOW is
	 -- window in that this class is mixed in
      do
	 result := Current
      end
   
   
feature {ANY} -- event handler 
   
   
   on_command : PROCEDURE[ANY,TUPLE[INTEGER]] is
	 -- Action that is invoked when user selects a page.
      require
	 not is_zombie
      do
	 result ?= find_callback_agent(On_command_event)
      end
   
   
   set_on_command (action: PROCEDURE[ANY,TUPLE[INTEGER]]) is
	 -- Sets a new handler for the 'on_command' event.
      require
	 not is_zombie
      do
	 set_callback_agent(On_command_event,action)
      end
   
   
feature {ANY} -- public interface
   
   
   Tab_top    : INTEGER is 0
   Tab_bottom : INTEGER is 1
   Tab_left   : INTEGER is 2
   Tab_right  : INTEGER is 3
   
   
   tab_orientation : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_tabbook__tab_orientation(handle)
      end
   
   
   set_tab_orientation (n: INTEGER) is
      require
	 not is_zombie
	 n.in_range(Tab_top, Tab_right)
      do
	 efox_tabbook__set_tab_orientation(handle, n)
      end
   
   
   current_page : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_tabbook__current_page(handle)
      end   
   
   
   set_current_page (n: INTEGER) is
      require
	 not is_zombie
	 n >= 1 and then n <= no_of_pages
      do
	 efox_tabbook__set_current_page(handle,n)
      end
   
   
   no_of_pages : INTEGER is
      require
	 not is_zombie
      do
	 result := efox_tabbook__no_of_pages(handle)
      end
   

feature {NONE} -- private C binding
   
   
   efox_tabbook__make (this:like Current; hnd,n,key: POINTER) : POINTER is
      external "C"
      end
	 
   efox__callback_command(idx: INTEGER; state: BOOLEAN; obj: ANY) is
      local
	 a: PROCEDURE[ANY,TUPLE[INTEGER]]
      do
	 a ?= find_callback_agent(On_command_event)
	 if a /= Void then
	    a.call([idx])
	 end
      end
   
   efox_tabbook__set_current_page(hnd: POINTER; n: INTEGER) is
      external "C"
      end
	 
   efox_tabbook__current_page(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_tabbook__set_tab_orientation(hnd: POINTER; n: INTEGER) is
      external "C"
      end      
   
   efox_tabbook__tab_orientation(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox_tabbook__no_of_pages(hnd: POINTER) : INTEGER is
      external "C"
      end
   
end

   
