class  AGUI_TREE_BOX
   
   
inherit
   AGUI_TREE_BASE
      end
   AGUI_FRAME_MIXIN
      end
   AGUI_PACKER_MIXIN
      end
   
   
creation
   {ANY} make
   
   
feature {ANY}
   
   
   set_visible_rows (n: INTEGER) is
	 -- Specifiy how many rows in the tree are visible in the popup.
      do
	 efox_tree_box__set_visible_rows(handle,n)
      end
   
   
   visible_rows : INTEGER is
	 -- Return number of visible rows.
      do
	 result := efox_tree_box__visible_rows(handle)
      end
   
   
feature {NONE} -- constructor
   
   
   make (p: AGUI_COMPOSITE; n: STRING) is
      require
	 p /= Void and n /= Void
      do
         handle := efox_tree_box__make(Current,p.handle, n.to_external, $temp_px)
	 efox__window_hash_table.put(Current, temp_px)
	 create item_dict.with_capacity(100)
      end
   
   
feature {ANY}  -- mixin configure
   
   
   mixin_window : AGUI_WINDOW is
	 -- redefine the mixin window references to this window
      do
	 result := Current
      end
   

feature {AGUI_TREE_BOX,AGUI_TREE_BOX_ITEM} -- private implementation
   
      
   efox_tree_box__make(this:like Current; ptr,str,k: POINTER) : POINTER is
      external "C"
      end
   
   efox_tree_box__set_visible_rows(hnd: POINTER; n:INTEGER) is
      external "C"
      end
   
   efox_tree_box__visible_rows(hnd: POINTER) : INTEGER is
      external "C"
      end
   
   efox__callback_destroy_item (i: AGUI_TREE_BOX_ITEM; key: INTEGER) is
      do
	 check item_dict.has(key) end
	 item_dict.remove(key)
	 i.mark_zombie
      end   

end
