class  AGUI_TREE_ITEM
   
inherit
   AGUI_TREE_BASE_ITEM
      end
   

creation
   {ANY} make, make_with_icon, make_as_child_with_icon, make_as_child
   

feature {NONE} -- constructor
   
   
   make (tree: AGUI_TREE; str: STRING) is
	 -- create an item
      require
	 tree /= Void and not tree.is_zombie
	 str /= Void
      do	 
	 handle := efox_tree_item__make (Current,tree.handle, str.to_external, $tree_kind)
	 tree.item_dict.put(Current, tree_kind)
	 tree_kind := 1
      end
   
   
   make_with_icon (tree: AGUI_TREE; str: STRING; ic: AGUI_ICON) is
	 -- create an item with an icon
      require
	 tree /= Void and not tree.is_zombie
	 str /= Void
	 ic /= Void implies not ic.is_zombie
      local
	 p : POINTER
      do
	 if ic /= Void then p := ic.handle end
	 handle := efox_tree_item__make_icon(Current,tree.handle, str.to_external, $tree_kind, p)
	 tree.item_dict.put(Current, tree_kind)
	 tree_kind := 1
      end
   
   
   make_as_child (parent: AGUI_TREE_ITEM; str: STRING) is
	 -- create an item as a child of 'parent'      
      require
	 parent /= Void and not parent.is_zombie
	 str /= Void
      do
	 handle := efox_tree_item__make_child(Current,parent.handle, str.to_external, $tree_kind)
	 parent.tree_window.item_dict.put(Current, tree_kind)
	 tree_kind := 1
      end
   
   
   make_as_child_with_icon (parent: AGUI_TREE_ITEM; str: STRING; ic: AGUI_ICON) is
	 -- create an item as a child of 'parent'      
      require
	 parent /= Void and not parent.is_zombie
	 str /= Void
	 ic /= Void implies not ic.is_zombie
      local
	 p : POINTER
      do
	 if ic /= Void then p := ic.handle end
	 handle := efox_tree_item__make_child_icon(Current,parent.handle, str.to_external, $tree_kind, p)
	 parent.tree_window.item_dict.put(Current, tree_kind)
	 tree_kind := 1
      end
   

feature {AGUI_TREE}
   
   
   mark_zombie is
      do
	 handle := default_pointer
      end
   

feature {NONE} -- private C binding
   
   efox_tree_item__make (this:like Current; thnd, str, lkind : POINTER) : POINTER is
      external "C" 
      end
   
   efox_tree_item__make_icon (this:like Current; thnd, str, lkind, ic : POINTER) : POINTER  is
      external "C" 
      end
   
   efox_tree_item__make_child (this:like Current; phnd, str, lkind : POINTER) : POINTER  is
      external "C" 
      end
   
   efox_tree_item__make_child_icon (this:like Current; phnd, str, lkind, ic : POINTER) : POINTER  is
      external "C" 
      end
   
end
   
