deferred class  AGUI_UTILITY_METHODS
   
   
-- This mixin class contains some commonly used code 
   
   
feature {ANY}   
   
   create_dialog_command_buttons(dlg: AGUI_DIALOG_WINDOW; flag:BOOLEAN; obj:ANY; ptr:POINTER) is
      local
	 f : AGUI_HORIZONTAL_FRAME	 
	 b : AGUI_BUTTON	 
      do
	 create f.make(dlg,"buttons")
	 f.set_layout_hints(f.Layout_fill_x + f.Layout_side_bottom)
	 f.set_packing_hints(f.Pack_uniform_height + f.Pack_uniform_width)
	 f.set_frame_style(f.Frame_groove, true) --IMPROVE separator
	 create b.make(f,"Okay")
	 b.set_text("Okay")
	 b.set_default_button(true)
	 if obj /= Void then
	    b.bind(b.Service_command_event, obj, ptr)
	 else
	    b.bind(b.Service_command_event, Current, $callback_dialog_okay_button)
	 end
	 create b.make(f,"Cancel")
	 b.set_text("Cancel")
	 b.bind(b.Service_command_event, Current, $callback_dialog_cancel_button)
	 if flag then
	    create b.make(f,"Help")
	    b.set_text("Help")
	    b.bind(b.Service_command_event, Current, $callback_dialog_help_button)
	 end
      end
   
   
   create_labeled_text_field(w: AGUI_COMPOSITE; label,name,tip: STRING; n: INTEGER; fl: BOOLEAN) is
      local
	 l : AGUI_LABEL
	 f : AGUI_TEXT_FIELD	 
      do   	    
	 create l.make(w,"l2")
	 l.set_text(label)
	 l.set_justify(l.Justify_right)
	 l.set_layout_hints(l.Layout_fill_x)
	 create f.make(w,name)
	 if fl then
	    f.set_layout_hints(l.Layout_fill_x)
	 end
	 if tip /= Void then
	    f.set_tooltip_text(tip)
	 end
	 if n > 0 then
	    f.set_visible_size(n)
	 end
   end
   
   
   callback_dialog_okay_button (a: AGUI_EVENT) is
      local
	 dlg : AGUI_DIALOG_WINDOW
      do
	 dlg ?= a.sender.shell_window
	 dlg.end_modal(1)
      end
   
   callback_dialog_help_button (a: AGUI_EVENT) is
      do
	 --TODO
      end
   
   callback_dialog_cancel_button (a: AGUI_EVENT) is
      local
	 dlg : AGUI_DIALOG_WINDOW
      do
	 dlg ?= a.sender.shell_window
	 dlg.end_modal(0)
      end
   
   
end
   
