class TEST_DIALOG
   
inherit
   TEST_HELPER
      end

creation
   make

feature
   
   p(s: STRING) is
      do
	 io.put_string(s + "%N")
      end
   
   
   color_dialog: AGUI_COLOR_DIALOG
   dir_dialog : AGUI_DIRECTORY_DIALOG
   file_dialog : AGUI_FILE_DIALOG
   
   
   show_file_dialog is
      local
	 f: AGUI_FILE_TOOLS
	 s,s2: STRING
      do
	 if file_dialog.is_zombie then
	    create file_dialog.make(Current)
	 end
	 s := f.current_directory
	 file_dialog.set_directory(s)
	 file_dialog.set_title("Non Modal Multiple File Select")
	 check file_dialog.title.is_equal("Non Modal Multiple File Select") end
	 file_dialog.set_on_finish(agent files_selected)
	 s2 := file_dialog.directory
	 check s2.same_as(s) end
	 file_dialog.set_pattern_list(<<"All Files (*)", "C++ Sources (*.cpp,*.cc,*.c)", "C++ Headers (*.hpp,*.hh,*.h)" >>)
	 check file_dialog.pattern_list.count = 3 end
	 p("1: " + file_dialog.pattern_list.item(1))
	 p("2: " + file_dialog.pattern_list.item(2))
	 p("3: " + file_dialog.pattern_list.item(3))
	 file_dialog.set_current_pattern(2)
	 check file_dialog.current_pattern = 2 end
	 file_dialog.set_file_name("hallo\foobar.e")
	 file_dialog.set_select_mode(file_dialog.Select_multiple)
	 check file_dialog.select_mode = file_dialog.Select_multiple end
	 file_dialog.show(file_dialog.Placement_cursor)
	 check file_dialog.is_visible end
      end
   
   
   files_selected is
	 -- asynchron call from file dialog when selection is done
      local
	 s: STRING
	 a: ARRAY[STRING]
	 i,n: INTEGER	 
      do
	 check not file_dialog.is_visible end
	 file_dialog.hide -- we don't need this,
	 if file_dialog.last_status then
	    p("OKAY pressed")
	    s := file_dialog.directory
	    p("selected directory: [" + s + "]")
	    a := file_dialog.file_names
	    from 
	       i := a.lower
	       n := a.upper
	    until
	       i > n
	    loop
	       p("file: [" + a.item(i) + "]")
	       i := i + 1
	    end
	 else
	    p("CANCEL pressed")
	 end
	 file_dialog.destroy
      end
   
   
   show_directory_dialog is
      local
	 f: AGUI_FILE_TOOLS
	 s,s2: STRING
      do
	 create dir_dialog.make(Current)
	 dir_dialog.position(700,0,300,600)
	 s := f.up_level(f.current_directory)
	 dir_dialog.set_directory(s)
	 s2 := dir_dialog.directory
	 check s2.same_as(s) end
	 dir_dialog.show_modal(dir_dialog.Placement_fixed)
	 if dir_dialog.last_status then
	    io.put_string("OKAY pressed%N")
	    s := dir_dialog.directory
	    io.put_string("selected: [" + s + "]%N")
	 else
	    io.put_string("CANCEL pressed%N")
	 end
	 dir_dialog.destroy
      end
   
   
   show_color_dialog is
      local
	 col: AGUI_COLOR
      do
	 col.from_rgb(255,0,0)
	 color_dialog.set_color(col)
	 check color_dialog.color = col end
	 color_dialog.set_opaque_colors_only(true)
--TODO	 check color_dialog.opaque_colors_only end
	 color_dialog.show_modal(color_dialog.Placement_screen)
	 if color_dialog.last_status then
	    io.put_string("OKAY pressed%N")
	    col := color_dialog.color
	    io.put_string("color: " + col.to_string + "%N")
	 else
	    io.put_string("CANCEL pressed%N")
	 end
      end
   
   
   show_font_dialog is
      do
      end 
   
   
   make is
      local
	 b: AGUI_BUTTON   
      do
	 init
	 create color_dialog.make(Current)
	 create file_dialog.make(Current)
	 
	 create b.make(Current, "file")
	 b.set_text("File Dialog")
	 b.set_on_command(agent show_file_dialog)
	 
	 create b.make(Current, "dir")
	 b.set_text("Directory Dialog")
	 b.set_on_command(agent show_directory_dialog)
	 
	 create b.make(Current, "color")
	 b.set_text("Color Dialog")
	 b.set_on_command(agent show_color_dialog)
	 
	 create b.make(Current, "font")
	 b.set_text("Font Dialog")
	 b.set_on_command(agent show_font_dialog)
         
	 application.add_timer_task(12000, agent application.stop)
	 application.run
      end   
   
end
