class TEST_EVENT_PORT
   
inherit
   TEST_HELPER
      end

creation
   make

feature
   
   msg : INTEGER
   b : AGUI_BUTTON
   t : AGUI_TEXT
   port : AGUI_EVENT_PORT
   receiver : STRING
   
   
   on_receive_agent (m, p1, p2: INTEGER) is
      do
	 io.put_string("received message: " + m.to_string + "%N")
	 io.put_string("         param 1: " + p1.to_string + "%N")
	 io.put_string("         param 2: " + p2.to_string + "%N")
	 t.append("received message " + p1.to_string + " - " + p2.to_string + "%N")
      end
   
   
   on_command_agent is
      do
	 io.put_string("Sending message%N")
	 port.transmit(receiver, msg, 10, 666)
	 if not port.transmit_result then
	    io.put_string("*********  Sending error **********%N")
	    die_with_code(1)
	 end
      end
   
   
   on_terminate_agent is
      do
	 io.put_string("terminated slave %N")
      end
      
      
   make is
      local
	 ft: AGUI_FILE_TOOLS
	 p: AGUI_PROCESS
      do
	 if argument_count = 0 then
	    --
	    --  This is the main application
	    --
	    
	    -- init application
	    init
	    create t.make(Current, "text")
	    
	    -- setup port
	    create port.make
	    msg := port.register_message("dreamworks notify")
	    port.set_on_receive(agent on_receive_agent)
	    
	    -- open port
	    port.open
	    if not port.is_open then
	       io.put_string("******  can't open port ******%N")
	       die_with_code(1)
	    end
	    
	    -- start slave process
	    create p.make
	    p.set_terminate_agent(agent on_terminate_agent)
	    p.execute(ft.binary_file + " " + port.name)
	    
	    -- send self button
	    create b.make(Current, "button")
	    receiver := port.name
	    b.set_text("Send Message to " + port.name)
	    b.set_on_command(agent on_command_agent)
	    
	    -- run
	    io.put_string("waiting for messages from: " + port.name)
	    application.add_timer_task (10000, agent application.stop)
	    position(400,100,default_width,default_height)
	    application.run
	    port.close
	    check not port.is_open end
	    destroy
	    
	 else
	    
	    --
	    -- we are inside the slave application
	    --	    
	    init
	    receiver := argument(1)
	    
	    create b.make(Current, "button")
	    b.set_text("Send Message to " + receiver)
	    b.set_on_command(agent on_command_agent)
	    
	    -- setup port
	    create port.make
	    msg := port.register_message("dreamworks notify")
	    position(100,100,200,100)
	    application.add_timer_task(2000, agent on_command_agent)
	    application.add_timer_task(2500, agent application.stop)
	    application.run
	 end
      end
   
   
end
