class   TEST_FILE_TOOLS
   
-- Test of classes:
--
--    AGUI_FILE_TOOLS
--

inherit
   AGUI_GLOBALS
      end
   
   
creation
   make
   
feature
   
   
   p(s: STRING) is
      do
	 io.put_string(s + "%N")
      end
   
   
   make is
      local
	 eiffel_bug: BUG_WORKAROUND
	 ft: AGUI_FILE_TOOLS
	 sys: AGUI_SYSTEM
	 s: STRING
	 a: ARRAY[STRING]
	 i,n: INTEGER
	 mtime,ctime: TIME_IN_GERMAN
      do
	 application.init("test_file_tools","MidnightSoft")
	 eiffel_bug.avoid
	 
	 p("home: " + ft.home_directory)
	 p("home of (Administrator): " + ft.user_directory("Administrator"))
	 p("current drive: " + ft.current_drive)
	 p("current_directory: " + ft.current_directory)
	 if sys.is_windows then
	    p("system directory: " +sys.system_directory)
	    p("goto root in current drive")
	    ft.set_current_directory(ft.current_drive+ft.path_separator)
	    p("current_directory is now: " + ft.current_directory)
	    check ft.current_directory.is_equal(ft.current_drive+ft.path_separator) end
	    p("binary executeable: " + ft.binary_file)
	 end
	 p("==========================")
         p("Enquote 'foo bar' is: " + ft.enquote("foo bar",false))
         p("Forced Enquote 'foobar' is: " + ft.enquote("foobar",true))
	 check ft.dequote(ft.enquote("foo bar",false)).is_equal("foo bar") end
	 check ft.dequote(ft.enquote("foo bar",true)).is_equal("foo bar") end
	 check ft.dequote(ft.enquote("foobar",false)).is_equal("foobar") end
	 check ft.dequote(ft.enquote("foobar",true)).is_equal("foobar") end
	 if sys.is_windows then
	    s := "e:\hello\world.txt"
	    --TODO wenn das nicht gesetzt dann liefert FOX einen 
	    --fehler : ===> Email an Jeroen.
	    ft.set_current_directory(ft.directory(ft.binary_file))
	    p("Drive from " + s + " : " + ft.drive(s))
	    check ft.drive(s).is_equal("e:") end
	    p("Directory from " + s + " : " + ft.directory(s))
	    check ft.directory(s).is_equal("e:\hello") end
	    p("Name from " + s + " : " + ft.name(s))
	    check ft.name(s).is_equal("world.txt") end
	    p("Title from " + s + " : " + ft.title(s))
	    check ft.title(s).is_equal("world") end
	    p("Extension from " + s + " : " + ft.extension(s))
	    check ft.extension(s).is_equal("txt") end
	    p("Strip extension from " + s + " : " + ft.strip_extension(s))
	    check ft.strip_extension(s).is_equal("e:\hello\world") end
	    ft.create_directory("foo")
	    s := ft.unique_name("foo\myapp.e"); ft.create_file(s)
	    p("unique 1: " + s) 
	    s := ft.unique_name("foo\myapp.e"); ft.create_file(s)
	    p("unique 2: " + s)
	    s := ft.unique_name("foo\myapp.e"); ft.create_file(s)
	    p("unique 3: " + s)
	    ft.remove("foo")
	    p("Simplify 'foo\\bar\..\..\\bar.e' : " + ft.simplify_path("foo\\bar\..\..\\bar.e"))
	    check ft.simplify_path("foo\\bar\..\..\\bar.e").is_equal(".\bar.e") end
	    p("Expand '%%AGUI%%\test\file_tools.exe' : " + ft.expand("%%AGUI%%\test\file_tools.exe"))
	    check ft.expand("%%AGUI%%\test\file_tools.exe").same_as(ft.binary_file) end
	    p("'..\test\test_file_tools.e' absolute: " + ft.absolute("..\test\test_file_tools.e"))
	    p("..\test\test_file_tools.e' absolute_from: " + ft.absolute_from_base(ft.current_directory,"..\test\test_file_tools.e"))
	    p("up_level: " + ft.up_level("e:\foo\bar"))
	    p("up_level: " + ft.up_level(ft.up_level("e:\foo\bar")))
	    p("up_level: " + ft.up_level(ft.up_level(ft.up_level("e:\foo\bar"))))
	    check ft.is_absolute("e:\foo\bar") end
	    --TODO fox bug: check not ft.is_absolute("\foo\bar") end
	    check not ft.is_absolute("foo\bar") end
	    check not ft.is_top_directory("foo\bar") end
	    check not ft.is_top_directory("e:\foo\bar") end
	    check not ft.is_top_directory("e:\foo") end
	    check ft.is_top_directory("\") end
	    check ft.is_top_directory("e:\") end
	    check ft.is_top_directory("e:") end
	    --TODO fox bug, does not work if parts of the path are enquoted
	    s := ft.up_level(ft.current_directory) + sys.pathlist_separator + ft.directory(ft.binary_file)
	    p("search in " + s + " : " + ft.search(s,"file_tools.exe"))
	    check ft.search(s,"file_tools.exe").same_as(ft.binary_file) end
	    --
	    -- information about files
	    --
	    ft.set_current_directory(ft.binary_file)
	    ft.set_current_drive(ft.drive(ft.binary_file))
	    check ft.is_file("file_tools.exe") end
	    check not ft.is_file(ft.directory(ft.binary_file)) end
	    check not ft.is_directory("file_tools.exe") end
	    check ft.is_directory(ft.directory(ft.binary_file)) end
	    check not ft.is_link("file_tools.exe") end
	    check not ft.is_link(ft.directory(ft.binary_file)) end
	    check ft.is_executable(ft.binary_file) end
	    check not ft.is_executable("test_file_tools.e") end
	    check ft.is_readable(ft.binary_file) end
	    check ft.is_writeable(ft.binary_file) end
	    ft.set_archived(ft.binary_file,false)
	    ft.set_archived("test_file_tools.e",false)
	    check not ft.is_archived(ft.binary_file) end
	    check not ft.is_archived("test_file_tools.e") end
	    ft.set_archived(ft.binary_file,true)
	    check ft.is_archived(ft.binary_file) end
	    ft.set_read_only(ft.binary_file, true) 
	    check not ft.is_writeable(ft.binary_file) end
	    ft.set_read_only(ft.binary_file, false) 
	    check ft.is_writeable(ft.binary_file) end
	    p("Size of executeable: " + ft.size(ft.binary_file).to_string)
	    check ft.exists(ft.binary_file) end
	    check not ft.exists("blabla.bla") end
	    check not ft.is_empty(ft.binary_file) end
	    ft.create_file("blabla.bla")
	    check not ft.is_empty(ft.binary_file) end
	    check ft.is_empty("blabla.bla") end
	    check ft.size("blabla.bla") = 0 end
	    ft.remove("blabla.bla")
	    check not ft.exists("blabla.bla") end
	    s := ft.read_symbolic_link(ft.binary_file) -- does nothing under windows
	    check ft.same_files("..\test\test_file_tools.e","test_file_tools.e") end
	    check not ft.same_files("test_file_tools.e","file_tools.exe") end
	    --
	    -- Basic file operations
	    --
	    ft.link("test_file_tools.e","bar",false)
  	    p("support hard links : " + ft.exists("bar").to_string)
	    ft.remove("bar")
	    check not ft.exists("bar moved") end
	    check not ft.exists("bar") end
	    check ft.exists("test_file_tools.e") end
	    ft.copy_file("test_file_tools.e", "bar", false)
	    ft.move("bar", "bar moved", false)
	    check ft.exists("bar moved") end
	    ft.delete("bar moved")
	    check not ft.exists("bar moved") end
	    ft.symbolic_link("test_file_tools.e","bar",true)
	    check not ft.exists("bar") end
	    ft.create_directory("bar")
	    s := "bar"+ft.path_separator+"foo"
	    ft.create_file(s)
	    check ft.is_directory("bar") end
	    check ft.is_file(s) end
	    check ft.is_empty(s) end
	    check not ft.exists("double_test") end
	    ft.concatenate("test_header.e", "test_file_tools.e", "double_test", true)
	    check ft.exists("double_test") end
	    check ft.size("test_header.e") + ft.size("test_file_tools.e") = ft.size("double_test") end
	    ft.destroy("bar")
	    check not ft.exists("bar") end
	    ft.remove("double_test")
	    check not ft.exists("double_test") end
	    p("Directory content: %N======================")
	    a := ft.scan_directory(".")
	    from
	       i := a.lower
	       n := a.upper
	       ctime.set_short_mode(true)
	       mtime.set_short_mode(true)
	    until
	       i > n
	    loop
	       if ft.match_name("*.e", a.item(i), ft.Match_file_name+ft.Match_case_insensitive) then
		  ctime.set_basic_time(ft.created_time(a.item(i)))
		  mtime.set_basic_time(ft.modified_time(a.item(i)))
		  s := "%T" + ctime.to_string + " %T " + mtime.to_string		  
		  p("file: " + a.item(i) + s)
	       end
	       i := i + 1
	    end
	    --
	    -- loading and saving of files
	    --
	    ft.store_content("foo", "bar%Nfoo%N", false)
	    check ft.size("foo") = 10 end
	    ft.load_content("foo", s, true)
	    check s.is_equal("bar%R%Nfoo%R%N") end
	    ft.load_content("foo", s, false)
	    check s.is_equal("bar%Nfoo%N") end
	    ft.remove("foo")
	    ft.store_content("bar", "bar%Nfoo%N", true)
	    check ft.size("bar") = 8 end
	    ft.load_content("bar", s, true)
	    check s.is_equal("bar%Nfoo%N") end
	    ft.load_content("bar", s, false)
	    check s.is_equal("bar%Nfoo%N") end
	    ft.remove("bar")
	 end
      end
   
end
