class  TEST_FONT
   
inherit
   AGUI_GLOBALS
      end
   
   
creation
   {AGUI_GLOBALS} make
   
   
feature
   
   fm : AGUI_FONT_MANAGER
   
   
   make is
      local
	 s1,s2: STRING
	 f1,f2: AGUI_FONT
	 eiffel_bug:  BUG_WORKAROUND
      do
	 application.init("test_font","MidnightSoft")
	 eiffel_bug.avoid
	 
	 fm := application.font_manager
	 fm.register("testfont1", "Courier New", 20, true, true)
	 check fm.last_register_status = true end
	 fm.register("testfont2", "Arial", 20, true, true)
	 check fm.last_register_status = true end
	 fm.register("this-font-does-not-exist", "this-font-does-not-exist", 20, true, true)
	 check fm.last_register_status = false end
	 
	 check fm.list_all_names.count = 2 end
	 check fm.list_all_names.lower = 1 end
	 s1 := fm.list_all_names.item(1)
	 s2 := fm.list_all_names.item(2)
	 check s1.is_equal("testfont1") or else s2.is_equal("testfont1") end
	 check s1.is_equal("testfont2") or else s2.is_equal("testfont2") end
	 check not s1.is_equal(s2) end
	 f1 := fm.find("testfont1")
	 f2 := fm.find("testfont2")
	 check fm.find("this-font-does-not-exist") = Void end
	 check f1 /= f2 end 
	 check fm.list_all_fonts.count = 2 end
	 check fm.list_all_fonts.lower = 1 end
	 check fm.list_all_fonts.item(1) = f1 or else fm.list_all_fonts.item(2) = f1 end 
	 check fm.list_all_fonts.item(1) = f2 or else fm.list_all_fonts.item(2) = f2 end 
	 check fm.contains("testfont1") end
	 check fm.contains("testfont2") end
	 check not fm.contains("this-font-does-not-exist") end
	 
	 --
	 --  Test font methods
	 --
	 check f1.name.is_equal("testfont1") end
	 check not f1.is_zombie end
	 check f1.is_proportional_font end
	 check not f2.is_proportional_font end
	 -- the following can't be asserted, but we
	 -- can output the values to check for compiler errors
	 io.put_string("Font: " + f1.name + "%N")
	 io.put_string("Height: " + f1.height.to_string + "%N")
	 io.put_string("Ascend: " + f1.ascend.to_string + "%N")
	 io.put_string("Descent: " + f1.descent.to_string + "%N")
	 io.put_string("Spacing: " + f1.spacing.to_string + "%N")
	 io.put_string("Width of %"Hello World%": " + f1.measure_string("Hello World").to_string + "%N")
	 io.put_string("Width of %"Hello World%": " + f1.measure_substring("  Hello World  ",3,13).to_string + "%N")
	 --
	 --
	 --  Test font delete
	 -- 
	 f1.destroy
	 check f1.is_zombie end
	 check fm.list_all_names.count = 1 end
	 check fm.list_all_fonts.count = 1 end	 
	 check fm.contains("testfont1") = false end	 
      end
	 
	 
end
