class TEST_HEADER
   
inherit
   TEST_HELPER
      end

creation
   make

feature
   
   --TODO test static tooltip
   
   
   header : AGUI_HEADER
   
   
   on_change_agent (column: INTEGER) is
      do
	 io.put_string("Change: column=" + column.to_string + "%N")
      end
   
   on_command_agent (column: INTEGER) is
      do
	 io.put_string("Command:  column=" + column.to_string + "%N")
      end
   
   on_tooltip_agent (column: INTEGER; s: STRING) is
      do
	 io.put_string("Tooltip: column=" + column.to_string + "%N")
	 s.copy("generated tooltip for column " + column.to_string)
      end
   
   on_context_menu_agent (column: INTEGER; menu: AGUI_POPUP_MENU) is
      local
	 mc: AGUI_MENU_COMMAND_ITEM
      do
	 io.put_string("Context Menu: column=" + column.to_string + "%N")
	 if column /= 2 then
	    create mc.make(menu,"Command (1) for " + column.to_string, Void)
	    create mc.make(menu,"Command (2) for " + column.to_string, Void)
	 end
      end
   
   
   
   build_header_columns is
      do
	 header.clear
	 check header.count = 0 end
	 header.append("Start",Void,100)
	 header.append("Second",Void,100)
	 header.append("Size",Void,100)
	 check header.count = 3 end
	 header.remove(2)
	 check header.count = 2 end
	 header.insert(2,"Second again",Void,100)
	 check header.count = 3 end
	 check header.item_text(1).is_equal("Start") end
	 check header.item_text(2).is_equal("Second again") end
	 check header.item_text(3).is_equal("Size") end
	 check not header.valid_position(0) end
	 check not header.valid_position_for_insert(0) end
	 check not header.valid_position(-1) end
	 check not header.valid_position_for_insert(-1) end
	 check header.valid_position(3) end
	 check header.valid_position_for_insert(3) end
	 check not header.valid_position(4) end
	 check header.valid_position_for_insert(4) end
	 check not header.valid_position_for_insert(5) end
      end
   
   
   change_header_properties is
      do
	 header.set_item_text(1, "New Column")
	 check header.item_text(1).is_equal("New Column") end
	 header.set_item_icon(1,icon1)
	 check header.item_icon(1) = icon1 end	 
	 header.set_button_mode(false)
	 check not header.button_mode end
	 header.set_button_mode(true)
	 check header.button_mode end
	 header.set_tracking(false)
	 check not header.tracking end
	 header.set_tracking(true)
	 check header.tracking end
	 header.set_horizontal_orientation(true)
	 check header.horizontal_orientation end
	 header.set_horizontal_orientation(false)
	 check not header.horizontal_orientation end
	 header.set_text_color(red_color)
	 check header.text_color = red_color end
	 header.set_font(font2)
	 check header.font = font2 end
	 header.set_arrow_direction(1,header.Arrow_ascending)
	 check header.arrow_direction(1) = header.Arrow_ascending end
	 header.set_arrow_direction(1,header.Arrow_none)
	 check header.arrow_direction(1) = header.Arrow_none end
	 header.set_arrow_direction(1,header.Arrow_descending)
	 check header.arrow_direction(1) = header.Arrow_descending end
	 header.set_item_size(1,100)
	 check header.item_size(1) = 100 end
	 check header.item_offset(1) = 0 end
	 check header.item_offset(2) = 100 end
	 check header.item_at(10) = 1 end
	 check header.item_at(110) = 2 end
      end
   
   
   make is
      do
	 init
	 create header.make(Current, "header")
	 
	 -- bind normal event handlers
	 install_normal_event_handlers(header)
	 
	 -- bind special event handlers
	 header.set_on_changed(agent on_change_agent)
	 check header.on_changed /= void end
	 header.set_on_command(agent on_command_agent)
	 check header.on_command /= Void end
	 header.set_on_tooltip(agent on_tooltip_agent)
	 check header.on_tooltip /= Void end
	 header.set_on_context_menu(agent on_context_menu_agent)
	 check header.on_context_menu /= Void end
	 
	 -- create columns in header
	 build_header_columns 
         application.add_timer_task(500, agent build_header_columns)
         application.add_timer_task(6000, agent change_header_properties)
         application.add_timer_task(12000, agent application.stop)
	 
	 -- start application
         application.run
         
	 -- check control
	 test_control_methods(header)
	 
	 -- check frame_mixin
	 test_frame_mixin_methods(header)
	 destroy	 
      end
   
   
end
