class  TEST_ICON
   
inherit
   AGUI_GLOBALS
      end
   
   
creation
   make
   
   
feature
   
   im : AGUI_ICON_MANAGER
   	 
   
   make is
      local
	 s1,s2: STRING
	 ic1,ic2: AGUI_ICON
	 eiffel_bug:  BUG_WORKAROUND
      do
	 application.init("test_icon","MidnightSoft")
	 eiffel_bug.avoid
	 
	 im := application.icon_manager
	 -- test registering a non existing icon
	 im.register("this-image-does-not-exist")
	 check im.last_register_status = false end
	 im.register("testicon1")
	 check im.last_register_status = true end
	 im.register("testicon2")
	 check im.last_register_status = true end
	 
	 check im.list_all_names.count = 2 end
	 check im.list_all_names.lower = 1 end
	 s1 := im.list_all_names.item(1)
	 s2 := im.list_all_names.item(2)
	 check s1.is_equal("testicon1") or else s2.is_equal("testicon1") end
	 check s1.is_equal("testicon2") or else s2.is_equal("testicon2") end
	 check not s1.is_equal(s2) end
	 ic1 := im.find("testicon1")
	 ic2 := im.find("testicon2")
	 check im.find("this-image-does-not-exist") = Void end
	 check ic1 /= ic2 end 
	 check im.list_all_icons.count = 2 end
	 check im.list_all_icons.lower = 1 end
	 check im.list_all_icons.item(1) = ic1 or else im.list_all_icons.item(2) = ic1 end 
	 check im.list_all_icons.item(1) = ic2 or else im.list_all_icons.item(2) = ic2 end 
	 check im.contains("testicon1") end
	 check im.contains("testicon2") end
	 check not im.contains("this-image-does-not-exist") end
	 
	 --
	 --  Test icon methods
	 --
	 check ic1.name.is_equal("testicon1") end
	 check ic1.width = 31 end
	 check ic1.height = 25 end
	 check not ic1.is_zombie end
	 
	 --
	 --  Test icon path manipulation
	 --
	 im.clear_path_list
	 im.add_path("C:\")
	 check im.list_all_names.count = 2 end
	 check im.list_all_icons.count = 2 end
	 im.register("testicon3")
	 check im.last_register_status = false end
	 
	 --
	 --  Test icon delete
	 -- 
	 ic1.destroy
	 check ic1.is_zombie end
	 check im.list_all_names.count = 1 end
	 check im.list_all_icons.count = 1 end	 
	 check im.contains("testicon1") = false end
      end
   
end
