class  TEST_MENU
   
inherit
   TEST_HELPER
      end
   
   
creation
   make
   

feature
   
   menubar: AGUI_MENUBAR
   statusbar: AGUI_STATUSBAR
   
   file,edit,help,submenu,subsubmenu: AGUI_MENU_CASCADE_ITEM
   file_exit,file_open, file_close: AGUI_MENU_COMMAND_ITEM
   
   edit_check : AGUI_MENU_CHECK_ITEM
   edit_change_check : AGUI_MENU_COMMAND_ITEM
   
   edit_radio1, edit_radio2, edit_radio3 : AGUI_MENU_RADIO_ITEM 
   edit_change_radio : AGUI_MENU_COMMAND_ITEM
   
   sep: AGUI_MENU_SEPARATOR_ITEM
   popup1,popup2 : AGUI_POPUP_MENU
   
	 -----------------------------------   
   
   build_submenu (m: AGUI_MENU_CASCADE_ITEM) is
      local
	 n : AGUI_MENU_COMMAND_ITEM
      do
	 create n.make(m, "Item: " + m.count.to_string,Void)
      end
   
   popup_callback (n: INTEGER) is
      do
	 io.put_string("popup select: " + n.to_string + "%N")
      end
   
   test_mouse_press (mod: BIT Integer_bits; x,y,button,clicks: INTEGER) is
      local
	 n : AGUI_MENU_COMMAND_ITEM
      do
	 create popup1.make
	 create n.make(popup1, "Popup 1", agent popup_callback(1))
	 create n.make(popup1, "Popup 2", agent popup_callback(2))
	 create n.make(popup1, "Popup 3", agent popup_callback(3))
	 popup1.show_and_destroy(find_window_by_name("popup1-button"),x,y,0)
	 check popup1.is_zombie end
	 consume_event
      end
   
   test_mouse_consume (mod: BIT Integer_bits; x,y,button,clicks: INTEGER) is
      do
	 consume_event
      end
   
   test_mouse_release (mod: BIT Integer_bits; x,y,button,clicks: INTEGER) is
      local
	 n : AGUI_MENU_COMMAND_ITEM
      do
	 popup2.clear
	 check popup2.count = 0 end
	 create n.make(popup2, "Popup 1", agent popup_callback(1))
	 create n.make(popup2, "Popup 2", agent popup_callback(2))
	 create n.make(popup2, "Popup 3", agent popup_callback(3))
	 check popup2.count = 3 end
	 popup2.show(find_window_by_name("popup2-button"),x,y,0)
	 consume_event
      end
   
	 ---------------------------------------------------
   
   test_menu_text_command_item is
      do
      end
   
	 ---------------------------------------------------
   
   menu_popup(m: AGUI_MENU) is
      do
	 io.put_string("Menu popup%N")
      end
   
   
   item_radio_callback(n: INTEGER) is
      do
	 io.put_string("Callback Radio: " + n.to_string + "%N")
      end
   
   
   item_callback (n: INTEGER) is
      do
	 io.put_string("Callback Command: " + n.to_string + "%N")
	 if n = 3 then
	    edit_check.set_checked(not edit_check.checked)
	 end
	 if n = 4 then
	    edit_radio1.set_checked(not edit_radio1.checked)
	 end
      end
   
   
   item_check_callback (flag: BOOLEAN) is
      do
	 io.put_string("Callback Check: " + flag.to_string + "%N")
	 check flag = edit_check.checked end
      end
   
   
   item_destroy is
      do
	 check not file_exit.is_zombie end
	 check not file_close.is_zombie end
	 check not file_open.is_zombie end
	 check not edit_radio1.is_zombie end
	 check not edit_radio2.is_zombie end
	 check not file.is_zombie end
	 sep.destroy
	 edit_check.destroy
	 edit_change_check.destroy
	 edit_radio1.destroy
	 file.destroy
	 check file_exit.is_zombie end
	 check file_close.is_zombie end
	 check file_open.is_zombie end
	 check edit_radio1.is_zombie end
	 check not edit_radio2.is_zombie end
	 check file.is_zombie end
      end
   

   make is
      local
	 nw: PROCEDURE[ANY,TUPLE]
	 b: AGUI_BUTTON
	 i: AGUI_MENU_COMMAND_ITEM
      do
	 init
	 create menubar.make(Current, "menubar")
	 create statusbar.make(Current, "statusbar")
	 
	 menubar.set_frame_style(menubar.Frame_groove, true)
	 create file.make(menubar, "File")
	 nw := agent menu_popup
	 file.set_on_popup(nw)
	 check file.on_popup = nw end
	 create edit.make(menubar, "Edit")
	 create file_open.make(file, "Open...", agent item_callback(1))
	 create sep.make(file)
	 create file_close.make(file, "Close...", agent item_callback(2))
	 file.smart_append_separator
	 file.smart_append_separator
	 create file_exit.make_with_icon(file, "Exit", icon1, agent item_callback(0))
	 create edit_check.make(edit, "Check item", agent item_check_callback)
	 create edit_change_check.make(edit, "Toggle check", agent item_callback(3))
	 create edit_radio1.make(edit,"Radio 1",2,666, agent item_radio_callback)
	 create edit_radio2.make(edit,"Radio 2",2,66, agent item_radio_callback)
	 create edit_radio3.make(edit,"Radio 3",2,6, agent item_radio_callback)
	 create edit_change_radio.make(edit, "Toggle radio", agent item_callback(4))
	 edit_radio1.set_group_item_id(666)
	 check edit_radio1.group_item_id = 666 end
	 check edit_radio1.group_id = 2 end
	 check edit_radio1.find_checked = -1 end
	 edit_radio3.set_checked(true)
	 check edit_radio1.find_checked = 6 end
	 check edit_radio3.checked end
	 create help.make(menubar, "help")
	 check menubar.help_menu = Void end
	 menubar.set_help_menu(help)
	 check menubar.help_menu = help end
	 
	 
	 --- test move item
	 check file.item(1) = file_open end
	 check file.item(2) = sep end
	 check file.item(3) = file_close end
	 check file.item(5) = file_exit end
	 check file.count = 5 end
	 file.move(2,3)
	 check file.item(1) = file_open end
	 check file.item(2) = file_close end
	 check file.item(3) = sep end
	 check file.item(5) = file_exit end
	 file.move(5,2)
	 check file.item(1) = file_open end
	 check file.item(2) = file_exit end
	 check file.item(3) = file_close end
	 check file.item(4) = sep end
	 check file.count = 5 end
	 
	 --- test cascaded submenu
	 create submenu.make_with_icon(edit,"Settings",icon2)
	 submenu.set_on_popup(agent build_submenu(submenu))
	 create subsubmenu.make(submenu,"Editor")
	 create i.make(subsubmenu,"Hello", Void)
	 create i.make(subsubmenu,"World", Void)
	 check subsubmenu.contains(i) end
	 check not subsubmenu.contains(submenu) end
	 check submenu.contains(subsubmenu) end
	 check subsubmenu.count = 2 end
	 check submenu.item(1) = subsubmenu end
	 
	 ------------  test AGUI_MENU_TEXT_ITEM
	 check file_open.enabled end
	 file_open.set_enabled(false)
	 check not file_open.enabled end
	 file_open.set_text("Open ...")
	 check file_open.text.is_equal("Open ...") end
	 file_open.set_icon(icon2)
	 check file_open.icon = icon2 end
	 file_close.set_tooltip_text("Tooltip test text");
	 check file_close.tooltip_text.is_equal("Tooltip test text") end
	 file_close.set_help_text("help text");
	 check file_close.help_text.is_equal("help text") end
	 check file_close.data = Void end
	 file_close.set_data(file_close)
	 check file_close.data = file_close end
	 check file_close.menu = file end
	 create_exit_button
	 
	 ---- Test AGUI_POPUP_MENU
	 create popup1.make
	 create popup2.make
	 create b.make(Current,"popup1-button")
	 b.set_text("popup menu on press");
	 b.set_on_mouse_release(agent test_mouse_consume) 
	 b.set_on_mouse_press(agent test_mouse_press)
	 create b.make(Current,"popup2-button")
	 b.set_text("popup menu on release");
	 b.set_on_mouse_release(agent test_mouse_release) 
	 b.set_on_mouse_press(agent test_mouse_consume) 
	 
	 application.add_timer_task(5000, agent item_destroy)
	 application.add_timer_task(10000, agent application.stop)	 
	 application.run
	 popup2.destroy
	 check popup2.is_zombie end
      end
   
   
end
