--  Test for classes:  
--
--     AGUI_TABBOOK  
--     AGUI_TAB_LABEL
--


class  TEST_TABBOOK
   
   
   
inherit
   TEST_LABEL_BASE
   end
   AGUI_MAIN_WINDOW
      rename make as make_main
      end
   AGUI_GLOBALS
      end
   
   
creation
   make

   
feature 
   
   --TODO test label
   
   switch_tab (n: INTEGER) is
      do
	 tabbook.set_tab_orientation(n)
	 check tabbook.tab_orientation = n end
      end
   
   switch_page (n: INTEGER) is
      do
	 tabbook.set_current_page(n)
	 check tabbook.current_page = n end
      end
   
   click_agent (n: INTEGER) is
      do
	 io.put_string("selected page: " + n.to_string + "%N")
      end
   
  
   
   tabbook: AGUI_TABBOOK
   item1, item2, item3:  AGUI_TAB_LABEL
   
   make is
      local
	 l: AGUI_LABEL
	 col : AGUI_COLOR
      do
	 init
	 make_main("main")
		      
	 create tabbook.make(Current,"tabbook")
	 tabbook.set_layout_hints(tabbook.Layout_fill_x + tabbook.Layout_fill_y)
	 install_normal_handler(tabbook)
	 
	 --
	 --  create three pages in the tabbook
	 --
	 check tabbook.no_of_pages = 1 end
	 
	 col.from_rgb(0,200,0)
	 create item1.make(tabbook, "item1")
	 item1.set_text("Debug")
	 item1.set_icon(icon1)
	 install_normal_handler(item1)
	 create l.make(tabbook, "b1")
	 l.set_text("Debugging Page")
	 l.set_layout_hints(l.Layout_fill_x + l.Layout_fill_y)
	 l.set_frame_style(l.Frame_groove, true)
	 item1.set_padding(30,30,30,30)
	 item1.set_frame_color(col)
	 item1.set_background_color(col)
	 
	 col.from_rgb(200,0,0) 
	 create item2.make(tabbook, "item2")
	 item2.set_text("Compiler")
	 item2.set_icon(icon2)	 
	 item2.set_frame_color(col)
	 item2.set_background_color(col)
	 install_normal_handler(item2)
	 create l.make(tabbook, "b1")
	 l.set_text("Compiler Page")
	 l.set_layout_hints(l.Layout_fill_x + l.Layout_fill_y)
	 l.set_frame_style(l.Frame_raised, true)
	 
	 col.from_rgb(200,200,0) 
	 create item3.make(tabbook, "item3")	 
	 item3.set_text("Editor")
	 item3.set_icon(icon3)
	 item3.set_frame_color(col)
	 item3.set_background_color(col)
	 install_normal_handler(item3)
	 create l.make(tabbook, "b2")
	 l.set_text("Editor Page")
	 l.set_layout_hints(l.Layout_fill_x + l.Layout_fill_y)
	 l.set_frame_style(l.Frame_sunken, true)
	 
	 check tabbook.no_of_pages = 3 end
	 
	 tabbook.set_current_page(2)
	 check tabbook.current_page(2) end
	 tabbook.set_on_click(agent click_agent)
	 
	 position(100,100,300,200)
	 set_visible(true)
	 application.add_timer_task(1000, agent switch_page(1))
	 application.add_timer_task(2000, agent switch_page(3))
	 application.add_timer_task(3000, agent switch_tab(tabbook.Tab_top))
	 application.add_timer_task(4000, agent switch_tab(tabbook.Tab_bottom))
	 application.add_timer_task(5000, agent switch_tab(tabbook.Tab_left))
	 application.add_timer_task(6000, agent switch_tab(tabbook.Tab_right))
	 application.add_timer_task(10000, agent destroy)
	 application.run
      end
   
end
   
   
