class  TEST_TEXT
   
inherit
   TEST_HELPER
      end

creation
   make

feature
   
   
   on_change_agent (what: STRING) is
      do
	 io.put_string("Change " + what + "%N")
      end
   
   on_command_agent (what: STRING) is
      do
	 io.put_string("Command " + what + "%N")
      end
   
   
   print_text_info is
      do
	 io.put_string("selection begin: " + text.selection_begin_position.to_string + "%N")
	 io.put_string("selection end: " + text.selection_end_position.to_string + "%N")
	 io.put_string("selection: [" + text.selection + "]%N")
      end
   
   
   text_field : AGUI_TEXT_FIELD
   text: AGUI_TEXT
   
   
   check_selection (f: AGUI_TEXT_BASE) is
      do
	 check not f.has_selection end
	 f.set_text("hello world - This is my toolkit")
	 check f.text.is_equal("hello world - This is my toolkit") end
	 f.select_all
	 check f.has_selection end
	 check f.selection_begin_position = 0 end
	 check f.selection_end_position = text.count end
	 check f.selection.is_equal("hello world - This is my toolkit") end
	 f.unselect_all
	 check not f.has_selection end
	 check f.selection_begin_position = 0 end	 
	 check f.selection_end_position = 0 end
	 check f.selection.is_equal("") end
	 f.select_range(1,3);
	 check f.selection_begin_position = 1 end
	 check f.selection_end_position = 4 end
	 check not f.is_position_selected(0) end
	 check f.is_position_selected(1) end
	 check f.is_position_selected(2) end
	 check f.is_position_selected(3) end
	 check f.is_position_selected(4) end
	 check not f.is_position_selected(5) end
	 check f.selection.is_equal("ell") end
	 check f.has_selection end
      end
   
   
   make is
      local
	 b : AGUI_BUTTON
      do
	 init
	 create text_field.make(Current, "textfield")
	 create text.make(Current, "text")
	 
	 -- bind special event handlers
	 text_field.set_on_changed(agent on_change_agent("TextField"))
	 check text_field.on_changed /= void end
	 text_field.set_on_command(agent on_command_agent("TextField"))
	 check text_field.on_command /= Void end
	 text.set_on_changed(agent on_change_agent("Text"))
	 check text.on_changed /= Void end
	 
--	 check_selection(text_field)
	 check_selection(text)
	 
	 text.set_visible_size(60,10)
	 text_field.set_visible_size(60,60)
	 
	 create b.make(Current, "foo")
	 b.set_text("Print Info")
	 b.set_on_command(agent print_text_info)
	 
	 application.add_timer_task(10000, agent application.stop)
         application.run         
	 destroy	 
      end
   
   
end
