class TEST_TREE
   
inherit
   TEST_HELPER
      end

creation
   make

feature
   
   tree : AGUI_TREE
   
   item : AGUI_TREE_ITEM
   
   
   
   collapse_agent (n: AGUI_TREE_BASE_ITEM) is
      do
	 io.put_string("collapse: " + n.text + "%N")
      end
   
   expand_agent (n: AGUI_TREE_BASE_ITEM) is
      do
	 io.put_string("expanding: " + n.text + "%N")
      end
   
   change_agent (n: AGUI_TREE_BASE_ITEM) is
      do
	 if n /= Void then
	    io.put_string("changing: " + n.text + "%N")
	 else
	    io.put_string("changing: <Void> %N")
	 end
      end
   
   command_agent (n: AGUI_TREE_BASE_ITEM) is
      do
	 io.put_string("command: " + n.text + "%N")
      end
   
   tooltip_agent (n: AGUI_TREE_BASE_ITEM; s: STRING) is
      do
	 s.copy("Program Tooltip supply: " + n.text)
      end
   
   
   context_menu_agent (n: AGUI_TREE_BASE_ITEM; p: AGUI_POPUP_MENU) is
      local
	 m: AGUI_MENU_COMMAND_ITEM
      do
	 create m.make(p, "Destroy", agent destroy_item(n))
	 create m.make(p, "Create child", agent child_item(n))
      end
   
   destroy_item (i: AGUI_TREE_BASE_ITEM) is
      do
	 i.destroy
      end
   
   child_item (i: AGUI_TREE_BASE_ITEM) is
      local
	 it : AGUI_TREE_ITEM
      do
	 it ?= i
	 create item.make_as_child(it, "New Child Item")
      end
   
   
   make is
      local
	 it : AGUI_TREE_ITEM
      do
	 init	 
	 create tree.make(Current, "tree")
	 tree.set_style(tree.Tree_show_lines + tree.Tree_show_boxes)
	 tree.set_indent(30)
	 tree.set_font(font2)
	 tree.set_visible_size(60,10)
	 tree.set_on_collapsed(agent collapse_agent)
	 tree.set_on_expanded(agent expand_agent)
	 tree.set_on_changed(agent change_agent)
	 tree.set_on_command(agent command_agent)
	 tree.set_on_query_tip(agent tooltip_agent)	 
	 tree.set_on_context_menu(agent context_menu_agent)
	 tree.set_select_style(tree.Tree_browse_selection)
	 
	 create item.make(tree, "MySQL")
	 it := item
	 create item.make_as_child(it, "Package")
	 create item.make_as_child(item, "Subpackage")
	 create item.make_as_child(item, "SubSubpackage")
	 tree.set_current_item(item)
	 item.make_visible         
	 item.set_collapsed(false)
	 tree.set_focus(true)
	 
	 
	 application.add_timer_task(12000, agent application.stop)
         application.run
	 destroy
      end
   
   
end
