deferred class TEST_UTILITY   
   
inherit
   TEST_HELPER
      end
   
feature {ANY}   -- subclass tests
   
   
   test_control (win: AGUI_CONTROL) is
      do
	 test_control_win := win
	 win.set_enabled(false)
	 check win.enabled = false end
	 win.set_help_text("Hello World")
	 check win.help_text.is_equal("Hello World") end
	 win.set_tooltip_text("Hello World")
	 check win.tooltip_text.is_equal("Hello World") end
	 application.add_timer_task(1000, agent test_control_callback)
	 application.add_timer_task(2000, agent application.stop)
      end
   
   
   test_control_callback is
      do
	 test_control_win.set_enabled(true)
	 check test_control_win.enabled = true end
      end
   
   
   test_control_win : AGUI_CONTROL
   
   --------------------------------------------------------------------------------
   
   
   test_label_base (win: AGUI_LABEL_BASE) is
      do
	 test_label_base_win := win
	 win.set_text("Hello Automatic Test")
	 check win.text.is_equal("Hello Automatic Test") end
	 win.set_icon(icon1)
	 check win.icon = icon1 end
	 win.set_font(font1)
	 check win.font = font1 end
	 win.set_text_color(red_color)
	 check win.text_color = red_color end
	 win.set_justify(win.Justify_center_x + win.Justify_center_y)
	 check win.justify = win.Justify_center_x + win.Justify_center_y end
	 application.add_timer_task(500, agent test_label_base_change_ip(0))
	 application.add_timer_task(1000, agent test_label_base_change_ip(1))
	 application.add_timer_task(1500, agent test_label_base_change_ip(2))
	 application.add_timer_task(2000, agent test_label_base_change_ip(3))
	 application.add_timer_task(2500, agent test_label_base_change_ip(4))
	 application.add_timer_task(3000, agent test_label_base_change_callback1)
	 application.add_timer_task(3500, agent application.stop)
      end
   
   
   test_label_base_change_ip(n: INTEGER) is
      local
	 win : AGUI_LABEL_BASE
      do
	 io.put_string("change icon position to [" + n.to_string + "]%N")
	 win := test_label_base_win
	 win.set_icon_position(n)
	 check win.icon_position = n end
      end
   
   
   test_label_base_change_callback1 is 
      local
	 win : AGUI_LABEL_BASE
      do
	 win := test_label_base_win
	 win.set_text("new text")
	 check win.text.is_equal("new text") end
	 win.set_icon(icon2)
	 check win.icon = icon2 end
	 win.set_font(font2)
	 check win.font = font2 end
	 win.set_text_color(blue_color)
	 check win.text_color = blue_color end
	 win.set_justify(win.Justify_right+win.Justify_bottom)
	 check win.justify = win.Justify_right+win.Justify_bottom end
      end
   
   
   test_label_base_win : AGUI_LABEL_BASE
   
   
   
   --------------------------------------------------------------------------------
   
   
   test_packer_mixin (win: AGUI_PACKER_MIXIN) is 
      do
	 test_packer_mixin_win := win
	 application.add_timer_task(1000,agent test_packer_mixin_callback(1))
	 application.add_timer_task(1500,agent test_packer_mixin_callback(2))
	 application.add_timer_task(2000,agent test_packer_mixin_callback(3))
	 application.add_timer_task(2500,agent test_packer_mixin_callback(4))
	 application.add_timer_task(3000,agent test_packer_mixin_callback(5))
	 application.add_timer_task(3500,agent test_packer_mixin_callback(6))
	 application.add_timer_task(4000,agent test_packer_mixin_callback(7))
	 application.add_timer_task(4500, agent application.stop)
      end
   
   
   test_packer_mixin_callback (n: INTEGER) is
      do
	 inspect n 
	 when 1 then  test_packer_mixin_win.set_spacing(100,100) 
	 when 2 then  test_packer_mixin_win.set_spacing(10,10) 
 	 when 3 then  test_packer_mixin_win.set_padding(100,100,100,100) 
	 when 4 then  test_packer_mixin_win.set_padding(10,10,10,10) 
	 when 5 then  test_packer_mixin_win.set_packing_hints(test_packer_mixin_win.Pack_uniform_width) 
	 when 6 then  test_packer_mixin_win.set_packing_hints(test_packer_mixin_win.Pack_uniform_height) 
	 when 7 then  test_packer_mixin_win.set_packing_hints(test_packer_mixin_win.Pack_uniform_width_and_height) 
	 end
      end
   
   
   test_packer_mixin_win : AGUI_PACKER_MIXIN
   
   
   --------------------------------------------------------------------------------
   
   
   test_frame_mixin (win: AGUI_FRAME_MIXIN) is
      do
	 test_frame_mixin_win := win
	 application.add_timer_task(1000,agent test_frame_mixin_callback(win.Frame_none, false, 1))
	 application.add_timer_task(1500,agent test_frame_mixin_callback(win.Frame_none, true, 2))
	 application.add_timer_task(2000,agent test_frame_mixin_callback(win.Frame_sunken, false, 3))
	 application.add_timer_task(2500,agent test_frame_mixin_callback(win.Frame_sunken, true, 4))
	 application.add_timer_task(3000,agent test_frame_mixin_callback(win.Frame_raised, false, 1))
	 application.add_timer_task(3500,agent test_frame_mixin_callback(win.Frame_raised, true, 2))
	 application.add_timer_task(4000,agent test_frame_mixin_callback(win.Frame_groove, false, 3))
	 application.add_timer_task(4500,agent test_frame_mixin_callback(win.Frame_groove, true, 4))
	 application.add_timer_task(5000,agent test_frame_mixin_callback(win.Frame_ridge, false, 1))
	 application.add_timer_task(5500,agent test_frame_mixin_callback(win.Frame_ridge, true, 2))
	 application.add_timer_task(6000,agent test_frame_mixin_callback(win.Frame_solid, false, 3))
	 application.add_timer_task(6500,agent test_frame_mixin_callback(win.Frame_solid, true, 4))
	 application.add_timer_task(7000, agent application.stop)
      end
   
   
   test_frame_mixin_callback (style: INTEGER; thick: BOOLEAN; col: INTEGER) is
      local
	 color : AGUI_COLOR
      do
	 test_frame_mixin_win.set_frame_style(style,thick)
	 inspect col
	 when 1 then color.from_rgb(255,0,0)
	 when 2 then color.from_rgb(0,255,0)
	 when 3 then color.from_rgb(0,0,255)
	 when 4 then color.from_rgb(255,0,255)
	 end
	 test_frame_mixin_win.set_frame_color(color)
      end
   
   
   test_frame_mixin_win : AGUI_FRAME_MIXIN
   
   
   --------------------------------------------------------------------------------
   
end
